/*
	Copyright (C) 2012 n0n3m4
	
    This file is part of DIII4A.

    DIII4A is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    DIII4A is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with DIII4A.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.n0n3m4.DIII4A;

import android.annotation.SuppressLint;
import android.app.ActionBar;
import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.content.res.Configuration;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.drawable.BitmapDrawable;
import android.graphics.drawable.ColorDrawable;
import android.graphics.drawable.Drawable;
import android.os.Build;
import android.os.Bundle;
import android.os.Environment;
import android.preference.PreferenceManager;
import android.provider.Settings;
import android.text.Editable;
import android.text.InputType;
import android.text.TextWatcher;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.SubMenu;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.SeekBar;
import android.widget.Spinner;
import android.widget.Switch;
import android.widget.TabHost;
import android.widget.TextView;
import android.widget.Toast;

import com.karin.idTech4Amm.OnScreenButtonConfigActivity;
import com.karin.idTech4Amm.R;
import com.karin.idTech4Amm.lib.ContextUtility;
import com.karin.idTech4Amm.lib.UIUtility;
import com.karin.idTech4Amm.lib.Utility;
import com.karin.idTech4Amm.misc.TextHelper;
import com.karin.idTech4Amm.sys.Constants;
import com.karin.idTech4Amm.sys.Game;
import com.karin.idTech4Amm.sys.GameManager;
import com.karin.idTech4Amm.sys.PreferenceKey;
import com.karin.idTech4Amm.sys.Theme;
import com.karin.idTech4Amm.ui.DebugDialog;
import com.karin.idTech4Amm.ui.ExperimentalDialog;
import com.karin.idTech4Amm.ui.FileTreeView;
import com.karin.idTech4Amm.ui.LauncherSettingsDialog;
import com.n0n3m4.DIII4A.launcher.AddExternalLibraryFunc;
import com.n0n3m4.DIII4A.launcher.BackupPreferenceFunc;
import com.n0n3m4.DIII4A.launcher.CVarEditorFunc;
import com.n0n3m4.DIII4A.launcher.CheckForUpdateFunc;
import com.n0n3m4.DIII4A.launcher.ChooseCommandRecordFunc;
import com.n0n3m4.DIII4A.launcher.ChooseExtrasFileFunc;
import com.n0n3m4.DIII4A.launcher.ChooseGameFolderFunc;
import com.n0n3m4.DIII4A.launcher.ChooseGameLibFunc;
import com.n0n3m4.DIII4A.launcher.ChooseGameModFunc;
import com.n0n3m4.DIII4A.launcher.CreateCommandShortcutFunc;
import com.n0n3m4.DIII4A.launcher.CreateShortcutFunc;
import com.n0n3m4.DIII4A.launcher.DebugPreferenceFunc;
import com.n0n3m4.DIII4A.launcher.DebugTextHistoryFunc;
import com.n0n3m4.DIII4A.launcher.DirectoryHelperFunc;
import com.n0n3m4.DIII4A.launcher.EditConfigFileFunc;
import com.n0n3m4.DIII4A.launcher.EditExternalLibraryFunc;
import com.n0n3m4.DIII4A.launcher.ExtractPatchResourceFunc;
import com.n0n3m4.DIII4A.launcher.ExtractSourceFunc;
import com.n0n3m4.DIII4A.launcher.GameChooserFunc;
import com.n0n3m4.DIII4A.launcher.OpenSourceLicenseFunc;
import com.n0n3m4.DIII4A.launcher.RestorePreferenceFunc;
import com.n0n3m4.DIII4A.launcher.SetupControlsThemeFunc;
import com.n0n3m4.DIII4A.launcher.StartGameFunc;
import com.n0n3m4.DIII4A.launcher.SupportDeveloperFunc;
import com.n0n3m4.DIII4A.launcher.TranslatorsFunc;
import com.n0n3m4.q3e.Q3EAd;
import com.n0n3m4.q3e.Q3EControlView;
import com.n0n3m4.q3e.Q3EGlobals;
import com.n0n3m4.q3e.Q3EInterface;
import com.n0n3m4.q3e.Q3EKeyCodes;
import com.n0n3m4.q3e.Q3ELang;
import com.n0n3m4.q3e.Q3EPreference;
import com.n0n3m4.q3e.Q3EUiConfig;
import com.n0n3m4.q3e.Q3EUtils;
import com.n0n3m4.q3e.gl.Q3EGLConstants;
import com.n0n3m4.q3e.karin.KLog;
import com.n0n3m4.q3e.karin.KStr;
import com.n0n3m4.q3e.karin.KUncaughtExceptionHandler;
import com.n0n3m4.q3e.karin.KidTechCommand;
import com.n0n3m4.q3e.onscreen.Q3EControls;

import java.io.File;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeSet;

@SuppressLint({"ApplySharedPref", "CommitPrefEdits"})
public class GameLauncher extends Activity
{
	private static final int CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_START               = 1;
	private static final int CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_EDIT_CONFIG_FILE    = 2;
	private static final int CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_FOLDER       = 3;
	private static final int CONST_RESULT_CODE_REQUEST_EXTRACT_PATCH_RESOURCE                   = 4;
	private static final int CONST_RESULT_CODE_REQUEST_BACKUP_PREFERENCES_CHOOSE_FILE           = 5;
	private static final int CONST_RESULT_CODE_REQUEST_RESTORE_PREFERENCES_CHOOSE_FILE          = 6;
	private static final int CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_GAME_LIBRARY = 7;
	private static final int CONST_RESULT_CODE_REQUEST_ADD_EXTERNAL_GAME_LIBRARY                = 8;
	private static final int CONST_RESULT_CODE_REQUEST_EDIT_EXTERNAL_GAME_LIBRARY               = 9;
	private static final int CONST_RESULT_CODE_REQUEST_EXTRACT_SOURCE                           = 10;
	private static final int CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_GAME_MOD     = 11;
	private static final int CONST_RESULT_CODE_ACCESS_ANDROID_DATA                              = 12;
	private static final int CONST_RESULT_CODE_REQUEST_CREATE_SHORTCUT                          = 13;
	private static final int CONST_RESULT_CODE_REQUEST_CREATE_SHORTCUT_WITH_COMMAND             = 14;
	private static final int CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_EXTRAS_FILE       = 15;

	private final GameManager m_gameManager = new GameManager();
	private final Map<String, RadioGroup> groupRadios = new HashMap<>();
    // GameLauncher function
	private ExtractPatchResourceFunc  m_extractPatchResourceFunc;
	private CheckForUpdateFunc        m_checkForUpdateFunc;
	private BackupPreferenceFunc      m_backupPreferenceFunc;
	private RestorePreferenceFunc     m_restorePreferenceFunc;
	private EditConfigFileFunc        m_editConfigFileFunc;
	private ChooseGameFolderFunc      m_chooseGameFolderFunc;
	private StartGameFunc             m_startGameFunc;
	private AddExternalLibraryFunc    m_addExternalLibraryFunc;
	private ChooseGameLibFunc         m_chooseGameLibFunc;
	private EditExternalLibraryFunc   m_editExternalLibraryFunc;
	private OpenSourceLicenseFunc     m_openSourceLicenseFunc;
	private ExtractSourceFunc         m_extractSourceFunc;
	private ChooseGameModFunc         m_chooseGameModFunc;
	private CreateShortcutFunc        m_createShortcutFunc;
	private CreateCommandShortcutFunc m_createCommandShortcutFunc;
	private ChooseExtrasFileFunc      m_chooseExtrasFileFunc;

    public static String default_gamedata = Environment.getExternalStorageDirectory() + "/diii4a";
    private final ViewHolder V = new ViewHolder();
    private boolean m_cmdUpdateLock = false;
	private String m_edtPathFocused = "";
    private final CompoundButton.OnCheckedChangeListener m_checkboxChangeListener = new CompoundButton.OnCheckedChangeListener() {
        @Override
        public void onCheckedChanged(CompoundButton buttonView, boolean isChecked)
        {
			int id = buttonView.getId();
			if (id == R.id.useetc1cache)
			{
				if(Q3EUtils.q3ei.IsIdTech4())
					setProp("r_useETC1cache", isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_useetc1cache, isChecked)
						.commit();
			}
			else if (id == R.id.nolight)
			{
				if(Q3EUtils.q3ei.IsIdTech4())
					setProp("r_noLight", isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_nolight, isChecked)
						.commit();
			}
			else if (id == R.id.useetc1)
			{
				if(Q3EUtils.q3ei.IsIdTech4())
					setProp("r_useETC1", isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_useetc1, isChecked)
						.commit();
			}
			else if (id == R.id.usedxt)
			{
				if(Q3EUtils.q3ei.IsIdTech4())
					setProp("r_useDXT", isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_usedxt, isChecked)
						.commit();
			}
			else if (id == R.id.detectmouse)
			{
				UpdateMouseManualMenu(!isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_detectmouse, isChecked)
						.commit();
			}
			else if (id == R.id.hideonscr)
			{
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_hideonscr, isChecked)
						.commit();
			}
			else if (id == R.id.smoothjoy)
			{
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_analog, isChecked)
						.commit();
			}
			else if (id == R.id.mapvol)
			{
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_mapvol, isChecked)
						.commit();
				UpdateMapVol(isChecked);
			}
			else if (id == R.id.secfinglmb)
			{
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_2fingerlmb, isChecked)
						.commit();
			}
			else if (id == R.id.fs_game_user)
			{
				UpdateUserGame(isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EUtils.q3ei.GetEnableModPreferenceKey(), isChecked)
						.commit();
			}
			else if (id == R.id.launcher_tab2_enable_gyro)
			{
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_view_motion_control_gyro, isChecked)
						.commit();
				UpdateEnableGyro(isChecked);
			}
			else if (id == R.id.auto_quick_load)
			{
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_auto_quick_load, isChecked)
						.commit();
				if (isChecked && (Q3EUtils.q3ei.IsIdTech4() || Q3EUtils.q3ei.isRTCW || Q3EUtils.q3ei.isRealRTCW))
					SetParam_temp("loadGame", "QuickSave");
				else
					RemoveParam_temp("loadGame");
			}
			else if (id == R.id.multithreading)
			{
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_multithreading, isChecked)
						.commit();
			}
			else if (id == R.id.launcher_tab2_joystick_unfixed)
			{
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_joystick_unfixed, isChecked)
						.commit();
				Q3EUtils.q3ei.joystick_unfixed = isChecked;
			}
			else if (id == R.id.using_mouse)
			{
				UpdateMouseMenu(isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_using_mouse, isChecked)
						.commit();
			}
			else if (id == R.id.find_dll)
			{
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_find_dll, isChecked)
						.commit();
			}
			else if (id == R.id.skip_intro)
			{
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_skip_intro, isChecked)
						.commit();
				if (isChecked)
					SetCommand_temp("disconnect", true);
				else
					RemoveCommand_temp("disconnect");
			}
/*			else if (id == R.id.scale_by_screen_area)
			{
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_scale_by_screen_area, isChecked)
						.commit();
			}*/
			else if (id == R.id.cb_s_useOpenAL)
			{
				if(Q3EUtils.q3ei.IsIdTech4())
					setProp("s_useOpenAL", isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_s_useOpenAL, isChecked)
						.commit();
				if(!isChecked)
				{
					V.cb_s_useEAXReverb.setChecked(false);
				}
				V.cb_s_useEAXReverb.setEnabled(isChecked);
			}
			else if (id == R.id.cb_s_useEAXReverb)
			{
				if(isChecked)
				{
					V.cb_s_useOpenAL.setChecked(true);
				}
				if(Q3EUtils.q3ei.IsIdTech4())
					setProp("s_useEAXReverb", isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_s_useEAXReverb, isChecked)
						.commit();
			}
			else if (id == R.id.readonly_command)
			{
				SetupCommandLine(!isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(PreferenceKey.READONLY_COMMAND, !isChecked)
						.commit();
			}
			else if (id == R.id.editable_temp_command)
			{
				SetupTempCommandLine(isChecked);
			}
			else if (id == R.id.cb_stencilShadowTranslucent)
			{
				if(Q3EUtils.q3ei.IsIdTech4())
					setProp("harm_r_stencilShadowTranslucent", isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_r_stencilShadowTranslucent, isChecked)
						.commit();
			}
			else if (id == R.id.cb_stencilShadowSoft)
			{
				if(Q3EUtils.q3ei.IsIdTech4())
					setProp("harm_r_stencilShadowSoft", isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_r_stencilShadowSoft, isChecked)
						.commit();
			}
			else if (id == R.id.cb_stencilShadowCombine)
			{
				if(Q3EUtils.q3ei.IsIdTech4())
					setProp("harm_r_stencilShadowCombine", isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_r_stencilShadowCombine, isChecked)
						.commit();
			}
			else if (id == R.id.image_useetc2)
			{
				if(Q3EUtils.q3ei.IsIdTech4())
					setProp("r_useETC2", isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_image_useetc2, isChecked)
						.commit();
			}
			else if (id == R.id.cb_perforatedShadow)
			{
				if(Q3EUtils.q3ei.IsIdTech4())
					setProp("r_forceShadowMapsOnAlphaTestedSurfaces", isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_r_shadowMapPerforatedShadow, isChecked)
						.commit();
			}
			else if (id == R.id.collapse_mods)
			{
				CollapseMods(isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(PreferenceKey.COLLAPSE_MODS, isChecked)
						.commit();
			}
			else if (id == R.id.cb_useHighPrecision)
			{
				if(Q3EUtils.q3ei.IsIdTech4())
					setProp("harm_r_useHighPrecision", isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_r_useHighPrecision, isChecked)
						.commit();
			}
			else if (id == R.id.cb_renderToolsMultithread)
			{
				if(Q3EUtils.q3ei.IsIdTech4())
					setProp("harm_r_renderToolsMultithread", isChecked);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_r_renderToolsMultithread, isChecked)
						.commit();
			}

			// Doom 3 BFG
			else if (id == R.id.doom3bfg_useCompressionCache)
			{
				if(Q3EUtils.q3ei.isD3BFG)
					setProp("harm_image_useCompressionCache", isChecked);
			}
			else if (id == R.id.doom3bfg_useMediumPrecision)
			{
				if(Q3EUtils.q3ei.isD3BFG)
					setProp("harm_r_useMediumPrecision", isChecked);
			}

			// RealRTCW
			else if (id == R.id.realrtcw_sv_cheats)
			{
				if(Q3EUtils.q3ei.isRealRTCW)
					setProp("harm_sv_cheats", isChecked);
			}
			else if (id == R.id.realrtcw_stencilShadowPersonal)
			{
				if(Q3EUtils.q3ei.isRealRTCW)
					setProp("harm_r_stencilShadowPersonal", isChecked);
			}

			// ETW
			else if (id == R.id.etw_omnibot_enable)
			{
				if(Q3EUtils.q3ei.isETW)
					setProp("omnibot_enable", isChecked);
			}
			else if (id == R.id.etw_stencilShadowPersonal)
			{
				if(Q3EUtils.q3ei.isETW)
					setProp("harm_r_stencilShadowPersonal", isChecked);
			}
			else if (id == R.id.etw_ui_disableAndroidMacro)
			{
				if(Q3EUtils.q3ei.isETW)
					setProp("harm_ui_disableAndroidMacro", isChecked);
			}

			// GZDOOM
			else if (id == R.id.gzdoom_load_lights_pk3)
			{
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_gzdoom_load_lights_pk3, isChecked)
						.commit();
				SetupGZDOOMFiles("file", "lights.pk3", isChecked);
			}
			else if (id == R.id.gzdoom_load_brightmaps_pk3)
			{
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_gzdoom_load_brightmaps_pk3, isChecked)
						.commit();
				SetupGZDOOMFiles("file", "brightmaps.pk3", isChecked);
			}

			// The Dark Mod
			else if (id == R.id.tdm_useMediumPrecision)
			{
				if(Q3EUtils.q3ei.isTDM)
					setProp("harm_r_useMediumPrecision", isChecked);
			}
        }
    };
    private final RadioGroup.OnCheckedChangeListener m_groupCheckChangeListener = new RadioGroup.OnCheckedChangeListener() {
        @Override
        public void onCheckedChanged(RadioGroup radioGroup, int id)
        {
            int index;
			int rgId = radioGroup.getId();
			if (rgId == R.id.r_harmclearvertexbuffer)
			{
				index = GetRadioGroupSelectIndex(radioGroup, id);
				if(Q3EUtils.q3ei.IsIdTech4())
					SetProp("harm_r_clearVertexBuffer", index);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putInt(Q3EPreference.pref_harm_r_harmclearvertexbuffer, index)
						.commit();
			}
			else if (rgId == R.id.rg_scrres)
			{
				index = GetRadioGroupSelectIndex(radioGroup, id);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putInt(Q3EPreference.pref_scrres_scheme, index)
						.commit();
				UpdateResolution(id);
			}
			else if (rgId == R.id.rg_harm_r_lightingModel)
			{
				String value = "" + ((GetRadioGroupSelectIndex(radioGroup, id) + 1) % V.rg_harm_r_lightingModel.getChildCount());
				if(Q3EUtils.q3ei.IsIdTech4())
					SetProp("harm_r_lightingModel", value);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putString(Q3EPreference.pref_harm_r_lightingModel, value)
						.commit();
			}
			else if (rgId == R.id.rg_msaa)
			{
				index = GetRadioGroupSelectIndex(radioGroup, id);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putInt(Q3EPreference.pref_msaa, index)
						.commit();
			}
			else if (rgId == R.id.rg_color_bits)
			{
				index = GetRadioGroupSelectIndex(radioGroup, id) - 1;
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_32bit, index == -1)
						.putInt(Q3EPreference.pref_harm_16bit, index)
						.commit();
			}
			else if (rgId == R.id.rg_curpos)
			{
				index = GetRadioGroupSelectIndex(radioGroup, id);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putInt(Q3EPreference.pref_mousepos, index)
						.commit();
			}
			else if (rgId == R.id.rg_s_driver)
			{
				String value2 = GetRadioGroupSelectIndex(radioGroup, id) == 1 ? "OpenSLES" : "AudioTrack";
				if(Q3EUtils.q3ei.IsIdTech4())
					SetProp("s_driver", value2);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putString(Q3EPreference.pref_harm_s_driver, value2)
						.commit();
			}
			else if (rgId == R.id.rg_harm_r_shadow)
			{
				boolean useShadowMapping = GetRadioGroupSelectIndex(radioGroup, id) == 1;
				String value = useShadowMapping ? "1" : "0";
				if(Q3EUtils.q3ei.IsIdTech4())
					SetProp("r_useShadowMapping", value);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putBoolean(Q3EPreference.pref_harm_r_useShadowMapping, useShadowMapping)
						.commit();
			}
			else if (rgId == R.id.rg_opengl)
			{
				int glVersion = GetRadioGroupSelectIndex(radioGroup, id) == 1 ? Q3EGLConstants.OPENGLES30 : Q3EGLConstants.OPENGLES20;
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putInt(Q3EPreference.pref_harm_opengl, glVersion)
						.commit();
			}
			else if (rgId == R.id.rg_r_autoAspectRatio)
			{
				index = GetRadioGroupSelectIndex(radioGroup, id);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putInt(Q3EPreference.pref_harm_r_autoAspectRatio, index)
						.commit();
				if (index > 0 && Q3EUtils.q3ei.IsIdTech4())
					SetProp_temp("harm_r_autoAspectRatio", index);
				else
					RemoveProp_temp("harm_r_autoAspectRatio");
			}
			else if (rgId == R.id.rg_depth_bits)
			{
				index = GetRadioGroupSelectIndex(radioGroup, id);
				int bits = Q3EPreference.DepthBitsByIndex(index);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putInt(Q3EPreference.pref_harm_depth_bit, bits)
						.commit();
			}

			// change game mods
			else if (
					rgId == R.id.rg_fs_game
					|| rgId == R.id.rg_fs_q4game
					|| rgId == R.id.rg_fs_preygame
					|| rgId == R.id.rg_fs_q2game
					|| rgId == R.id.rg_fs_q3game
					|| rgId == R.id.rg_fs_rtcwgame
					|| rgId == R.id.rg_fs_tdmgame
					|| rgId == R.id.rg_fs_q1game
					|| rgId == R.id.rg_fs_d3bfggame
					|| rgId == R.id.rg_fs_doomgame
					|| rgId == R.id.rg_fs_etwgame
					|| rgId == R.id.rg_fs_realrtcwgame
					|| rgId == R.id.rg_fs_fteqwgame
			)
			{
				RadioButton checked = radioGroup.findViewById(id);
				SetGameInternalMod((String)checked.getTag());
			}

			// Quake 2
			else if (rgId == R.id.yquake2_vid_renderer)
			{
				if(Q3EUtils.q3ei.isQ2)
				{
					String value2 = GetRadioGroupSelectIndex(radioGroup, id) == 1 ? "gles3" : "gl1";
					SetProp("vid_renderer", value2);
				}
			}

			// Doom 3 BFG
			else if (rgId == R.id.doom3bfg_useCompression)
			{
				if(Q3EUtils.q3ei.isD3BFG)
				{
					index = GetRadioGroupSelectIndex(radioGroup, id);
					SetProp("harm_image_useCompression", index);
				}
			}
			else if (rgId == R.id.doom3bfg_rendererBackend)
			{
				if(Q3EUtils.q3ei.isD3BFG)
				{
					index = GetRadioGroupSelectIndex(radioGroup, id);
					String rb = index == 1 ? "Vulkan" : "OpenGL";
					PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
							.putString(Q3EPreference.pref_harm_d3bfg_rendererBackend, rb)
							.commit();
				}
			}

			// RealRTCW
			else if (rgId == R.id.realrtcw_shadows)
			{
				if(Q3EUtils.q3ei.isRealRTCW)
				{
					index = GetRadioGroupSelectIndex(radioGroup, id);
					SetProp("cg_shadows", index);
				}
			}

			// ETW
			else if (rgId == R.id.etw_shadows)
			{
				if(Q3EUtils.q3ei.isETW)
				{
					index = GetRadioGroupSelectIndex(radioGroup, id);
					SetProp("cg_shadows", index);
				}
			}

			// GZDOOM
			else if (rgId == R.id.gzdoom_vid_preferbackend)
			{
				if(Q3EUtils.q3ei.isDOOM)
				{
					int value2 = GetRadioGroupSelectIndex(radioGroup, id);
					RemovePropPrefix(KidTechCommand.ARG_PREFIX_ALL, "vid_preferbackend");
					SetPropPrefix(KidTechCommand.ARG_PREFIX_IDTECH, "vid_preferbackend", value2);
				}
			}
			else if (rgId == R.id.gzdoom_gl_es)
			{
				if(Q3EUtils.q3ei.isDOOM)
				{
					int value2 = GetRadioGroupSelectIndex(radioGroup, id);
					if(value2 > 0)
						value2++;
					RemovePropPrefix(KidTechCommand.ARG_PREFIX_ALL, "harm_gl_es");
					SetPropPrefix(KidTechCommand.ARG_PREFIX_IDTECH, "harm_gl_es", value2);
				}
			}
			else if (rgId == R.id.gzdoom_gl_version)
			{
				if(Q3EUtils.q3ei.isDOOM)
				{
					int value2 = GetRadioGroupSelectIndex(radioGroup, id);
					value2 = value2 >= 0 && value2 < Q3EGlobals.GZDOOM_GL_VERSIONS.length ? Q3EGlobals.GZDOOM_GL_VERSIONS[value2] : 0;
					RemovePropPrefix(KidTechCommand.ARG_PREFIX_ALL, "harm_gl_version");
					SetPropPrefix(KidTechCommand.ARG_PREFIX_IDTECH, "harm_gl_version", value2);
				}
			}

			// FTEQW
			else if (rgId == R.id.fteqw_vid_renderer)
			{
				if(Q3EUtils.q3ei.isFTEQW)
				{
					int value2 = GetRadioGroupSelectIndex(radioGroup, id);
					RemovePropPrefix(KidTechCommand.ARG_PREFIX_ALL, "vid_renderer");
					SetPropPrefix(KidTechCommand.ARG_PREFIX_IDTECH, "vid_renderer", value2 == 0 ? "vk" : "gl");
				}
			}
        }
    };
    private final View.OnClickListener m_buttonClickListener = new View.OnClickListener() {
        @Override
        public void onClick(View view)
        {
			int id = view.getId();
			if (id == R.id.launcher_tab1_edit_autoexec)
			{
				EditFile("autoexec.cfg", false);
			}
			else if (id == R.id.launcher_tab1_edit_doomconfig)
			{
				EditFile(Q3EUtils.q3ei.config_name, true);
			}
			else if (id == R.id.launcher_tab1_game_lib_button)
			{
				OpenGameLibChooser();
			}
			else if (id == R.id.launcher_tab1_game_data_chooser_button)
			{
				OpenFolderChooser();
			}
			else if (id == R.id.onscreen_button_setting)
			{
				OpenOnScreenButtonSetting();
			}
			else if (id == R.id.setup_onscreen_button_theme)
			{
				OpenOnScreenButtonThemeSetting();
			}
			else if (id == R.id.launcher_tab1_edit_cvar)
			{
				EditCVar();
			}
			else if (id == R.id.launcher_tab1_game_mod_button)
			{
				OpenGameModChooser();
			}
			else if (id == R.id.launcher_tab1_command_record)
			{
				OpenCommandChooser();
			}
			else if (id == R.id.launcher_tab1_create_shortcut)
			{
				OpenShortcutWithCommandCreator();
			}
			else if (id == R.id.show_directory_helper)
			{
				OpenDirectoryHelper();
			}
			else if (id == R.id.launcher_tab1_patch_resource)
			{
				OpenResourceFileDialog(false);
			}
			else if (id == R.id.gzdoom_choose_extras_file)
			{
				OpenExtrasFileChooser();
			}
        }
    };

	private final AdapterView.OnItemSelectedListener m_itemSelectedListener = new AdapterView.OnItemSelectedListener()
	{
		@Override
		public void onItemSelected(AdapterView<?> parent, View view, int position, long id)
		{
			int viewId = parent.getId();
			if(viewId == R.id.launcher_tab2_joystick_visible)
			{
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putInt(Q3EPreference.pref_harm_joystick_visible, getResources().getIntArray(R.array.joystick_visible_mode_values)[position])
						.commit();
			}
		}

		@Override
		public void onNothingSelected(AdapterView<?> parent)
		{
			int viewId = parent.getId();
			if(viewId == R.id.launcher_tab2_joystick_visible)
			{
				int position = Utility.ArrayIndexOf(getResources().getIntArray(R.array.joystick_visible_mode_values), Q3EGlobals.ONSCRREN_JOYSTICK_VISIBLE_ALWAYS);
				parent.setSelection(position);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putInt(Q3EPreference.pref_harm_joystick_visible, Q3EGlobals.ONSCRREN_JOYSTICK_VISIBLE_ALWAYS)
						.commit();
			}
		}
	};

	private final SeekBar.OnSeekBarChangeListener m_seekListener = new SeekBar.OnSeekBarChangeListener() {
		@Override
		public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser)
		{
			if(seekBar.getId() == V.consoleHeightFracValue.getId())
			{
				if(fromUser)
				{
					PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
							.putInt(Q3EPreference.pref_harm_max_console_height_frac, progress)
							.commit();
					V.consoleHeightFracText.setText(GetConsoleHeightText(progress));
				}
			}
		}

		@Override
		public void onStartTrackingTouch(SeekBar seekBar)
		{

		}

		@Override
		public void onStopTrackingTouch(SeekBar seekBar)
		{

		}
	};
    private class SavePreferenceTextWatcher implements TextWatcher
    {
        private final String name;
        private final String defValue;
		private final Runnable runnable;

        public SavePreferenceTextWatcher(String name, String defValue)
        {
            this(name, defValue, null);
        }

		public SavePreferenceTextWatcher(String name, String defValue, Runnable runnable)
		{
			this.name = name;
			this.defValue = defValue;
			this.runnable = runnable;
		}

        public SavePreferenceTextWatcher(String name)
        {
            this(name, null);
        }

        public void onTextChanged(CharSequence s, int start, int before, int count)
        {
        }

        public void beforeTextChanged(CharSequence s, int start, int count, int after)
        {
        }

        public void afterTextChanged(Editable s)
        {
            String value = s.length() == 0 && null != defValue ? defValue : s.toString();
            PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
                    .putString(name, value)
                    .commit();
			if(null != runnable)
				runnable.run();
        }
    }
	private class SaveFloatPreferenceTextWatcher implements TextWatcher
	{
		private final String name;
		private final String preference;
		private final float defValue;

        public SaveFloatPreferenceTextWatcher(String name, String preference, float defValue)
		{
			this.name = name;
			this.preference = preference;
			this.defValue = defValue;
		}

		public void onTextChanged(CharSequence s, int start, int before, int count)
		{
			if(Q3EUtils.q3ei.IsIdTech4())
				SetProp(name, s);
		}

		public void beforeTextChanged(CharSequence s, int start, int count, int after)
		{
		}

		public void afterTextChanged(Editable s)
		{
			String value = s.length() == 0 ? "" + defValue : s.toString();
			Q3EPreference.SetFloatFromString(GameLauncher.this, preference, value, defValue);
		}
	}

	private class CommandTextWatcher implements TextWatcher
	{
		private boolean enabled;

		public boolean IsEnabled()
		{
			return enabled;
		}

		public void Install(boolean e)
		{
			enabled = e;
		}

		public void Uninstall()
		{
			enabled = false;
		}

		public void onTextChanged(CharSequence s, int start, int before, int count)
		{
			boolean cond = enabled && V.edt_cmdline.isInputMethodTarget() && !IsCmdUpdateLocked();
			if (cond)
				updatehacktings();
		}

		public void afterTextChanged(Editable s)
		{
			String value = s.length() == 0 ? Q3EGlobals.GAME_EXECUABLE : s.toString();
			PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
					.putString(Q3EUtils.q3ei.GetGameCommandPreferenceKey(), value)
					.commit();
		}

		public void beforeTextChanged(CharSequence s, int start, int count, int after) {}
	}
	private final CommandTextWatcher m_commandTextWatcher = new CommandTextWatcher();

    private final AdapterView.OnItemSelectedListener m_spinnerItemSelectedListener = new AdapterView.OnItemSelectedListener()
    {
        public void onItemSelected(AdapterView adapter, View view, int position, long id)
        {
            int[] keyCodes;
			int vid = adapter.getId();
			if (vid == R.id.launcher_tab2_volume_up_map_config_keys)
			{
				keyCodes = getResources().getIntArray(R.array.key_map_codes);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putInt(Q3EPreference.VOLUME_UP_KEY, keyCodes[position])
						.commit();
			}
			else if (vid == R.id.launcher_tab2_volume_down_map_config_keys)
			{
				keyCodes = getResources().getIntArray(R.array.key_map_codes);
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putInt(Q3EPreference.VOLUME_DOWN_KEY, keyCodes[position])
						.commit();
			}
        }

        public void onNothingSelected(AdapterView adapter)
        {
        }
    };

    private void InitUIDefaultLayout(Q3EInterface q3ei)
    {
		q3ei.defaults_table = Q3EControls.GetDefaultLayout(this, Q3EControls.CONST_DEFAULT_ON_SCREEN_BUTTON_FRIENDLY_EDGE, Q3EControls.CONST_DEFAULT_ON_SCREEN_BUTTON_SIZE_SCALE, Q3EControls.CONST_DEFAULT_ON_SCREEN_BUTTON_OPACITY, false);
    }

    public void InitQ3E(String game)
    {
        // Q3EKeyCodes.InitD3Keycodes();
        Q3EInterface q3ei = new Q3EInterface();
		SharedPreferences mPrefs = PreferenceManager.getDefaultSharedPreferences(this);
		q3ei.standalone = mPrefs.getBoolean(Q3EPreference.GAME_STANDALONE_DIRECTORY, true);

        q3ei.InitD3();

        InitUIDefaultLayout(q3ei);

        q3ei.default_path = default_gamedata;
		q3ei.datadir = mPrefs.getString(Q3EPreference.pref_datapath, default_gamedata); //k add 20241113

        q3ei.SetupDOOM3(); //k armv7-a only support neon now

        // Q3EInterface.DumpDefaultOnScreenConfig(q3ei.arg_table, q3ei.type_table);

		q3ei.LoadTypeAndArgTablePreference(this);

		if(null != game && !game.isEmpty())
			q3ei.SetupGame(game);

        Q3EUtils.q3ei = q3ei;

		Q3EUtils.q3ei.joystick_release_range = mPrefs.getFloat(Q3EPreference.pref_harm_joystick_release_range, 0.0f);
		Q3EUtils.q3ei.joystick_unfixed = mPrefs.getBoolean(Q3EPreference.pref_harm_joystick_unfixed, false);
		Q3EUtils.q3ei.joystick_inner_dead_zone = mPrefs.getFloat(Q3EPreference.pref_harm_joystick_inner_dead_zone, 0.0f);
    }

	@Override
	public void onWindowFocusChanged(boolean hasFocus)
	{
		super.onWindowFocusChanged(hasFocus);
		if(hasFocus)
			CollapseMods(V.collapse_mods.isChecked());
	}

	@Override
    public void onAttachedToWindow()
    {
        super.onAttachedToWindow();
        InitUIDefaultLayout(Q3EUtils.q3ei);
    }

    @Override
    public void onConfigurationChanged(Configuration newConfig)
    {
        Q3EAd.LoadAds(this);
        super.onConfigurationChanged(newConfig);
    }

    public void support(View vw)
    {
        new SupportDeveloperFunc(this).Start(new Bundle());
    }

    public void UpdateMouseMenu(boolean show)
    {
        final boolean supportGrabMouse = Q3EUtils.SupportMouse() == Q3EGlobals.MOUSE_EVENT;
        V.tv_mprefs.setVisibility(supportGrabMouse ? LinearLayout.GONE : LinearLayout.VISIBLE);
        V.layout_mouse_device.setVisibility(supportGrabMouse ? LinearLayout.GONE : LinearLayout.VISIBLE);
        V.layout_mouseconfig.setVisibility(show ? LinearLayout.VISIBLE : LinearLayout.GONE);
    }

    public void UpdateMouseManualMenu(boolean show)
    {
        final boolean supportGrabMouse = Q3EUtils.SupportMouse() == Q3EGlobals.MOUSE_EVENT;
        V.layout_manualmouseconfig.setVisibility(!supportGrabMouse && show ? LinearLayout.VISIBLE : LinearLayout.GONE);
    }

	private void EnableRadioGroup(RadioGroup rg, boolean enabled)
	{
		for (int i = 0; i < rg.getChildCount(); i++)
		{
			View item = rg.getChildAt(i);
			if (item instanceof RadioButton)
			{
				item.setEnabled(enabled);
				//item.setClickable(enabled);
			}
		}
		rg.setEnabled(enabled);
		rg.setClickable(enabled);
	}

	private void SelectRadioGroup(RadioGroup rg, int index)
    {
        for (int i = 0, j = 0; i < rg.getChildCount(); i++)
        {
            View item = rg.getChildAt(i);
            if (item instanceof RadioButton)
            {
                if (j == index)
                {
                    rg.check(item.getId());
                    return;
                }
                j++;
            }
        }
        //rg.check(rg.getChildAt(index).getId());
    }


	private int GetRadioGroupSelectIndex(RadioGroup rg)
    {
        return GetRadioGroupSelectIndex(rg, rg.getCheckedRadioButtonId());
    }

	private int GetRadioGroupSelectIndex(RadioGroup rg, int id)
    {
        for (int i = 0, j = 0; i < rg.getChildCount(); i++)
        {
            View item = rg.getChildAt(i);
            if (item instanceof RadioButton)
            {
                if (item.getId() == id)
                {
                    return j;
                }
                j++;
            }
        }
        return -1;
        //return rg.indexOfChild(findViewById(rg.getCheckedRadioButtonId()));
    }

	private RadioButton GetRadioGroupSelectItem(RadioGroup rg)
	{
		for (int i = 0; i < rg.getChildCount(); i++)
		{
			View item = rg.getChildAt(i);
			if (item instanceof RadioButton)
			{
				RadioButton gb = (RadioButton)item;
				if(gb.isChecked())
					return gb;
			}
		}
		return null;
	}

    public boolean getProp(String name)
    {
		Boolean b = Q3EUtils.q3ei.GetGameCommandEngine(GetCmdText()).GetBoolProp(name, false);
        // Boolean b = KidTech4Command.GetBoolProp(GetCmdText(), name, false);
        return null != b ? b : false;
    }

    public void setProp(String name, boolean val)
    {
        SetProp(name, KidTechCommand.btostr(val));
    }

	// update widget from command line
    public void updatehacktings()
    {
    	LockCmdUpdate();
		String str;
		int index;

		if(Q3EUtils.q3ei.IsIdTech4()) // only for idTech4 games
		{
			//k
			V.usedxt.setChecked(getProp("r_useDXT", false));
			V.useetc1.setChecked(getProp("r_useETC1", false));
			V.useetc1cache.setChecked(getProp("r_useETC1cache", false));
			V.nolight.setChecked(getProp("r_noLight", false));

			//k fill commandline
			if (!IsProp("r_useDXT")) setProp("r_useDXT", false);
			if (!IsProp("r_useETC1")) setProp("r_useETC1", false);
			if (!IsProp("r_useETC1cache")) setProp("r_useETC1cache", false);
			if (!IsProp("r_noLight")) setProp("r_noLight", false);

			V.image_useetc2.setChecked(getProp("r_useETC2", false));
			if (!IsProp("r_useETC2")) setProp("r_useETC2", false);

			str = GetProp("harm_r_clearVertexBuffer");
			index = Q3EUtils.parseInt_s(str, 2);
			SelectRadioGroup(V.r_harmclearvertexbuffer, index);
			if (!IsProp("harm_r_clearVertexBuffer")) SetProp("harm_r_clearVertexBuffer", 2);

			str = GetProp("harm_r_lightingModel");
			index = 0;
			if (str != null)
			{
				index = Q3EUtils.parseInt_s(str, 1) - 1;
				if(index < 0)
					index = V.rg_harm_r_lightingModel.getChildCount() - 1;
			}
			SelectRadioGroup(V.rg_harm_r_lightingModel, index);
			if (!IsProp("harm_r_lightingModel")) SetProp("harm_r_lightingModel", "1");

			str = GetProp("harm_r_specularExponent");
			if (null != str)
				V.edt_harm_r_specularExponent.setText(str);
			if (!IsProp("harm_r_specularExponent")) SetProp("harm_r_specularExponent", "3.0");

			str = GetProp("harm_r_specularExponentBlinnPhong");
			if (null != str)
				V.edt_harm_r_specularExponentBlinnPhong.setText(str);
			if (!IsProp("harm_r_specularExponentBlinnPhong")) SetProp("harm_r_specularExponentBlinnPhong", "12.0");

			str = GetProp("harm_r_specularExponentPBR");
			if (null != str)
				V.edt_harm_r_specularExponentPBR.setText(str);
			if (!IsProp("harm_r_specularExponentPBR")) SetProp("harm_r_specularExponentPBR", "5.0");

			str = GetProp("harm_r_ambientLightingBrightness");
			if (null != str)
				V.edt_harm_r_ambientLightingBrightness.setText(str);
			if (!IsProp("harm_r_ambientLightingBrightness")) SetProp("harm_r_ambientLightingBrightness", "1.0");

			str = GetProp("s_driver");
			index = 0;
			if (str != null)
			{
				if ("OpenSLES".equalsIgnoreCase(str))
					index = 1;
			}
			SelectRadioGroup(V.rg_s_driver, index);

			str = GetProp("r_maxFps");
			if (null != str)
				V.edt_harm_r_maxFps.setText(str);
			if (!IsProp("r_maxFps")) SetProp("r_maxFps", "0");

			str = GetProp("r_useShadowMapping");
			index = 0;
			if (str != null)
			{
				if ("1".equalsIgnoreCase(str))
					index = 1;
			}
			SelectRadioGroup(V.rg_harm_r_shadow, index);
			if (!IsProp("r_useShadowMapping")) SetProp("r_useShadowMapping", "0");
			str = GetProp("harm_r_shadowMapAlpha");
			if (null != str)
				V.edt_harm_r_shadowMapAlpha.setText(str);
			if (!IsProp("harm_r_shadowMapAlpha")) SetProp("harm_r_shadowMapAlpha", "1.0");

			V.cb_stencilShadowTranslucent.setChecked(getProp("harm_r_stencilShadowTranslucent", false));
			if (!IsProp("harm_r_stencilShadowTranslucent")) setProp("harm_r_stencilShadowTranslucent", false);
			str = GetProp("harm_r_stencilShadowAlpha");
			if (null != str)
				V.edt_harm_r_stencilShadowAlpha.setText(str);
			if (!IsProp("harm_r_stencilShadowAlpha")) SetProp("harm_r_stencilShadowAlpha", "1.0");

			V.cb_stencilShadowSoft.setChecked(getProp("harm_r_stencilShadowSoft", false));
			if (!IsProp("harm_r_stencilShadowSoft")) setProp("harm_r_stencilShadowSoft", false);
			V.cb_stencilShadowCombine.setChecked(getProp("harm_r_stencilShadowCombine", false));
			if (!IsProp("harm_r_stencilShadowCombine")) setProp("harm_r_stencilShadowCombine", false);
			V.cb_perforatedShadow.setChecked(getProp("r_forceShadowMapsOnAlphaTestedSurfaces", false));
			if (!IsProp("r_forceShadowMapsOnAlphaTestedSurfaces")) setProp("r_forceShadowMapsOnAlphaTestedSurfaces", false);

			V.cb_s_useOpenAL.setChecked(getProp("s_useOpenAL", false));
			if (!IsProp("s_useOpenAL"))
			{
				setProp("s_useOpenAL", false);
				V.cb_s_useEAXReverb.setChecked(false);
				setProp("s_useEAXReverb", false);
			}
			else
			{
				V.cb_s_useEAXReverb.setChecked(getProp("s_useEAXReverb", false));
				if (!IsProp("s_useEAXReverb")) setProp("s_useEAXReverb", false);
			}

			V.cb_useHighPrecision.setChecked(getProp("harm_r_useHighPrecision", false));
			if (!IsProp("harm_r_useHighPrecision")) setProp("harm_r_useHighPrecision", false);

			V.cb_renderToolsMultithread.setChecked(getProp("harm_r_renderToolsMultithread", false));
			if (!IsProp("harm_r_renderToolsMultithread")) setProp("harm_r_renderToolsMultithread", false);
		}
		else if(Q3EUtils.q3ei.isQ2)
		{
			Updatehacktings_Quake2();
		}
		else if(Q3EUtils.q3ei.isD3BFG)
		{
			Updatehacktings_Doom3BFG();
		}
		else if(Q3EUtils.q3ei.isRealRTCW)
		{
			Updatehacktings_RealRTCW();
		}
		else if(Q3EUtils.q3ei.isETW)
		{
			Updatehacktings_ETW();
		}
		else if(Q3EUtils.q3ei.isDOOM)
		{
			Updatehacktings_GZDOOM();
		}
		else if(Q3EUtils.q3ei.isTDM)
		{
			Updatehacktings_TDM();
		}
		else if(Q3EUtils.q3ei.isFTEQW)
		{
			Updatehacktings_FTEQW();
		}

		// game mods for every games
		str = GetGameModFromCommand();
		if (!V.fs_game_user.isChecked()) // internal game
		{
			if (str != null)
			{
				GameManager.GameProp prop = m_gameManager.ChangeGameMod(str, false);
				if(prop.IsValid())
				{
					SelectRadioGroup(GetGameModRadioGroup(), prop.index);
				}
/*				else
				{
					RemoveGameModFromCommand();
					RemoveProp("fs_game_base");
				}*/
			}
			else
			{
				SelectRadioGroup(GetGameModRadioGroup(), -1);
			}
		}
		else // user mod
		{
			if (str != null)
			{
				GameManager.GameProp prop = m_gameManager.ChangeGameMod(str, false);
				if(!prop.IsValid())
				{
					String cur = V.edt_fs_game.getText().toString();
					if (!str.equals(cur))
						V.edt_fs_game.setText(str);
				}
			}
			else
			{
				{
					String cur = V.edt_fs_game.getText().toString();
					if (!"".equals(cur))
						V.edt_fs_game.setText("");
				}
			}
		}

		// graphics
		int checkedRadioButtonId = V.rg_scrres.getCheckedRadioButtonId();
		UpdateResolution(checkedRadioButtonId);

		UnlockCmdUpdate();
    }

	private void Updatehacktings_Quake2()
	{
		String str;
		int index;

		str = GetProp("vid_renderer");
		index = 0;
		if (str != null)
		{
			if ("gles3".equalsIgnoreCase(str))
				index = 1;
		}
		SelectRadioGroup(V.yquake2_vid_renderer, index);
	}

	private void Updatehacktings_Doom3BFG()
	{
		String str;
		int index;

		str = GetProp("harm_image_useCompression");
		index = 0;
		if (str != null)
		{
			index = Q3EUtils.parseInt_s(str, 0);
		}
		SelectRadioGroup(V.doom3bfg_useCompression, index);

		V.doom3bfg_useCompressionCache.setChecked(getProp("harm_image_useCompressionCache", false));
		if (!IsProp("harm_image_useCompressionCache")) setProp("harm_image_useCompressionCache", false);

		V.doom3bfg_useMediumPrecision.setChecked(getProp("harm_r_useMediumPrecision", false));
		if (!IsProp("harm_r_useMediumPrecision")) setProp("harm_r_useMediumPrecision", false);

		str = PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).getString(Q3EPreference.pref_harm_d3bfg_rendererBackend, "OpenGL");
		index = "Vulkan".equalsIgnoreCase(str) ? 1 : 0;
		SelectRadioGroup(V.doom3bfg_rendererBackend, index);
	}

	private void Updatehacktings_TDM()
	{
		V.tdm_useMediumPrecision.setChecked(getProp("harm_r_useMediumPrecision", false));
		if (!IsProp("harm_r_useMediumPrecision")) setProp("harm_r_useMediumPrecision", false);
	}

	private void Updatehacktings_RealRTCW()
	{
		String str;
		int index;

		str = GetProp("cg_shadows");
		index = 0;
		if (str != null)
		{
			index = Q3EUtils.parseInt_s(str, 1);
		}
		SelectRadioGroup(V.realrtcw_shadows, index);

		V.realrtcw_sv_cheats.setChecked(getProp("harm_sv_cheats", false));
		if (!IsProp("harm_sv_cheats")) setProp("harm_sv_cheats", false);

		V.realrtcw_stencilShadowPersonal.setChecked(getProp("harm_r_stencilShadowPersonal", true));
		if (!IsProp("harm_r_stencilShadowPersonal")) setProp("harm_r_stencilShadowPersonal", true);
	}

	private void Updatehacktings_ETW()
	{
		String str;
		int index;

		V.etw_omnibot_enable.setChecked(getProp("omnibot_enable", false));
		if (!IsProp("omnibot_enable")) setProp("omnibot_enable", false);

		str = GetProp("cg_shadows");
		index = 0;
		if (str != null)
		{
			index = Q3EUtils.parseInt_s(str, 1);
		}
		SelectRadioGroup(V.etw_shadows, index);

		V.etw_stencilShadowPersonal.setChecked(getProp("harm_r_stencilShadowPersonal", true));
		if (!IsProp("harm_r_stencilShadowPersonal")) setProp("harm_r_stencilShadowPersonal", true);

		V.etw_ui_disableAndroidMacro.setChecked(getProp("harm_ui_disableAndroidMacro", false));
		if (!IsProp("harm_ui_disableAndroidMacro")) setProp("harm_ui_disableAndroidMacro", false);
	}

	private void Updatehacktings_GZDOOM()
	{
		String str;
		int index;

		str = GetPropPrefix(KidTechCommand.ARG_PREFIX_ALL, "vid_preferbackend");
		index = 2;
		if (str != null)
		{
			index = Q3EUtils.parseInt_s(str, 2);
		}
		SelectRadioGroup(V.gzdoom_vid_preferbackend, index);

		str = GetPropPrefix(KidTechCommand.ARG_PREFIX_ALL, "harm_gl_es");
		index = 0;
		if (str != null)
		{
			index = Q3EUtils.parseInt_s(str, 0);
			if(index > 0)
				index--;
		}
		SelectRadioGroup(V.gzdoom_gl_es, index);

		str = GetPropPrefix(KidTechCommand.ARG_PREFIX_ALL, "harm_gl_version");
		index = 0;
		if (str != null)
		{
			index = Q3EUtils.parseInt_s(str, 0);
			index = Utility.ArrayIndexOf(Q3EGlobals.GZDOOM_GL_VERSIONS, index);
			if(index < 0)
				index = 0;
		}
		SelectRadioGroup(V.gzdoom_gl_version, index);
	}

	private void Updatehacktings_FTEQW()
	{
		String str;
		int index;

		str = GetPropPrefix(KidTechCommand.ARG_PREFIX_ALL, "vid_renderer");
		index = 1;
		if (str != null)
		{
			index = "vk".equalsIgnoreCase(str) ? 0 : 1;
		}
		SelectRadioGroup(V.fteqw_vid_renderer, index);
	}

    private void ThrowException()
    {
        ((String) null).toString();
    }

    private void ShowDebugTextHistoryDialog()
    {
        new DebugTextHistoryFunc(this).Start(new Bundle());
    }

	private void EnableGameChooser(boolean enabled)
	{
		for(RadioGroup rg : groupRadios.values())
		{
			EnableRadioGroup(rg, enabled);
		}
	}

    private void UpdateUserGame(boolean on)
    {
		EnableGameChooser(!on);
		RadioGroup radioGroup = GetGameModRadioGroup();

		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(GameLauncher.this);
		String game = null;
		boolean isUser;
		if(on) // user mod enabled
		{
			game = preference.getString(Q3EUtils.q3ei.GetGameUserModPreferenceKey(), "");
			if (null == game)
				game = "";
			isUser = true;
		}
		else
		{
			RadioButton rb = GetRadioGroupSelectItem(radioGroup);
			if(null == rb)
			{
				SelectRadioGroup(radioGroup, 0);
				rb = GetRadioGroupSelectItem(radioGroup);
			}
			if(null != rb)
			{
				game = rb.getTag().toString();
				GameManager.GameProp prop = m_gameManager.ChangeGameMod(game, true);
				game = prop.fs_game;
				isUser = prop.is_user;
			}
			else
			{
				game = "";
				isUser = false;
			}
		}

        preference.edit().putString(Q3EPreference.pref_harm_game_lib, "").commit();
		if (!isUser && game.isEmpty())
			RemoveGameModFromCommand();
		else
			SetGameModToCommand(game);
        V.fs_game_user.setText(on ? R.string.mod_ : R.string.user_mod);
        V.edt_fs_game.setEnabled(on);
        //V.launcher_tab1_user_game_layout.setVisibility(on ? View.VISIBLE : View.GONE);
    }

    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);

		default_gamedata = Q3EUtils.GetDefaultGameDirectory(this);
		Q3EUtils.DumpPID(this);
        Q3ELang.Locale(this);

        //k
        KUncaughtExceptionHandler.HandleUnexpectedException(this);
        setTitle(R.string.app_title);
        final SharedPreferences mPrefs = PreferenceManager.getDefaultSharedPreferences(this);
        ContextUtility.SetScreenOrientation(this, mPrefs.getBoolean(PreferenceKey.LAUNCHER_ORIENTATION, false) ? 0 : 1);

		Theme.SetTheme(this, false);
        setContentView(R.layout.main);

        ActionBar actionBar = getActionBar();
        if (null != actionBar)
            actionBar.setDisplayHomeAsUpEnabled(true);

        InitQ3E(null); // gameType
        Q3EUtils.q3ei.SetAppStoragePath(this);

        TabHost th = (TabHost) findViewById(R.id.tabhost);
        th.setup();
        th.addTab(th.newTabSpec("tab1").setIndicator(Q3ELang.tr(this, R.string.general)).setContent(R.id.launcher_tab1));
        th.addTab(th.newTabSpec("tab2").setIndicator(Q3ELang.tr(this, R.string.controls)).setContent(R.id.launcher_tab2));
        th.addTab(th.newTabSpec("tab3").setIndicator(Q3ELang.tr(this, R.string.graphics)).setContent(R.id.launcher_tab3));

        V.Setup();

		InitGameList();

		SetupUI();

        updatehacktings();

		AfterCreated();
    }

	private void SetupUI()
	{
		final SharedPreferences mPrefs = PreferenceManager.getDefaultSharedPreferences(this);

		String gameType = mPrefs.getString(Q3EPreference.pref_harm_game, Q3EGlobals.GAME_DOOM3);

		V.main_ad_layout.setVisibility(mPrefs.getBoolean(PreferenceKey.HIDE_AD_BAR, true) ? View.GONE : View.VISIBLE);

		SetGame(gameType);

		V.edt_cmdline.setText(mPrefs.getString(Q3EUtils.q3ei.GetGameCommandPreferenceKey(), Q3EGlobals.GAME_EXECUABLE));
		V.edt_mouse.setText(mPrefs.getString(Q3EPreference.pref_eventdev, "/dev/input/event???"));
		V.edt_path.setText(mPrefs.getString(Q3EPreference.pref_datapath, default_gamedata));
		m_edtPathFocused = V.edt_path.getText().toString();
		if(ContextUtility.InScopedStorage())
		{
			V.edt_path.setOnFocusChangeListener(new View.OnFocusChangeListener() {
				@Override
				public void onFocusChange(View v, boolean hasFocus) {
					String curPath = V.edt_path.getText().toString();
					if(curPath.equals(m_edtPathFocused))
						return;
					if(!hasFocus)
					{
						OpenSuggestGameWorkingDirectory(curPath);
					}
				}
			});
		}
		V.hideonscr.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.hideonscr.setChecked(mPrefs.getBoolean(Q3EPreference.pref_hideonscr, false));
		V.using_mouse.setChecked(mPrefs.getBoolean(Q3EPreference.pref_harm_using_mouse, false));
		V.using_mouse.setOnCheckedChangeListener(m_checkboxChangeListener);

		UpdateMouseMenu(V.using_mouse.isChecked());

		V.mapvol.setChecked(mPrefs.getBoolean(Q3EPreference.pref_mapvol, false));
		V.secfinglmb.setChecked(mPrefs.getBoolean(Q3EPreference.pref_2fingerlmb, false));
		V.smoothjoy.setChecked(mPrefs.getBoolean(Q3EPreference.pref_analog, true));
		V.launcher_tab2_joystick_unfixed.setChecked(mPrefs.getBoolean(Q3EPreference.pref_harm_joystick_unfixed, false));
		V.launcher_tab2_joystick_visible.setSelection(Utility.ArrayIndexOf(getResources().getIntArray(R.array.joystick_visible_mode_values), mPrefs.getInt(Q3EPreference.pref_harm_joystick_visible, Q3EGlobals.ONSCRREN_JOYSTICK_VISIBLE_ALWAYS)));
		V.detectmouse.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.detectmouse.setChecked(mPrefs.getBoolean(Q3EPreference.pref_detectmouse, true));

		UpdateMouseManualMenu(!V.detectmouse.isChecked());

		SelectRadioGroup(V.rg_curpos, mPrefs.getInt(Q3EPreference.pref_mousepos, 3));
		V.rg_scrres.setOnCheckedChangeListener(m_groupCheckChangeListener);
		SelectRadioGroup(V.rg_scrres, mPrefs.getInt(Q3EPreference.pref_scrres_scheme, 0));
		int scrresScheme = Utility.Step(mPrefs.getInt(Q3EPreference.pref_scrres_scale, 100), 10);
		V.res_scale.setProgress(scrresScheme);
		V.tv_scale_current.setText(V.res_scale.getProgress() + "%");
		V.res_scale.setOnSeekBarChangeListener(new SeekBar.OnSeekBarChangeListener() {
			@Override
			public void onProgressChanged(SeekBar seekBar, int progress, boolean fromUser)
			{
				int newProgress = Utility.Step(progress, 10);
				if(newProgress != progress)
				{
					seekBar.setProgress(newProgress);
					return;
				}
				V.tv_scale_current.setText(progress + "%");
			}

			@Override
			public void onStartTrackingTouch(SeekBar seekBar)
			{

			}

			@Override
			public void onStopTrackingTouch(SeekBar seekBar)
			{
				mPrefs.edit().putInt(Q3EPreference.pref_scrres_scale, seekBar.getProgress()).commit();
				UpdateResolutionText();
			}
		});
		SelectRadioGroup(V.rg_msaa, mPrefs.getInt(Q3EPreference.pref_msaa, 0));
		V.rg_msaa.setOnCheckedChangeListener(m_groupCheckChangeListener);
		//k
		V.usedxt.setChecked(mPrefs.getBoolean(Q3EPreference.pref_usedxt, false));
		V.useetc1.setChecked(mPrefs.getBoolean(Q3EPreference.pref_useetc1, false));
		V.useetc1cache.setChecked(mPrefs.getBoolean(Q3EPreference.pref_useetc1cache, false));
		V.nolight.setChecked(mPrefs.getBoolean(Q3EPreference.pref_nolight, false));
		V.image_useetc2.setChecked(mPrefs.getBoolean(Q3EPreference.pref_harm_image_useetc2, false));
		SelectRadioGroup(V.rg_color_bits, mPrefs.getInt(Q3EPreference.pref_harm_16bit, -1) + 1);
		V.rg_color_bits.setOnCheckedChangeListener(m_groupCheckChangeListener);
		SelectRadioGroup(V.r_harmclearvertexbuffer, mPrefs.getInt(Q3EPreference.pref_harm_r_harmclearvertexbuffer, 2));
		V.r_harmclearvertexbuffer.setOnCheckedChangeListener(m_groupCheckChangeListener);
		int index = Q3EUtils.parseInt_s(mPrefs.getString(Q3EPreference.pref_harm_r_lightingModel, "1"), 1) - 1;
		if(index < 0)
			index = V.rg_harm_r_lightingModel.getChildCount() - 1;
		SelectRadioGroup(V.rg_harm_r_lightingModel, index);
		V.rg_harm_r_lightingModel.setOnCheckedChangeListener(m_groupCheckChangeListener);
		SelectRadioGroup(V.rg_s_driver, "OpenSLES".equalsIgnoreCase(mPrefs.getString(Q3EPreference.pref_harm_s_driver, "AudioTrack")) ? 1 : 0);
		V.rg_s_driver.setOnCheckedChangeListener(m_groupCheckChangeListener);
		SelectRadioGroup(V.rg_harm_r_shadow, mPrefs.getBoolean(Q3EPreference.pref_harm_r_useShadowMapping, false) ? 1 : 0);
		V.rg_harm_r_shadow.setOnCheckedChangeListener(m_groupCheckChangeListener);
		SelectRadioGroup(V.rg_opengl, mPrefs.getInt(Q3EPreference.pref_harm_opengl, Q3EGLConstants.GetPreferOpenGLESVersion()) == Q3EGLConstants.OPENGLES30 ? 1 : 0);
		V.rg_opengl.setOnCheckedChangeListener(m_groupCheckChangeListener);
		V.launcher_tab2_enable_gyro.setChecked(mPrefs.getBoolean(Q3EPreference.pref_harm_view_motion_control_gyro, false));
		int autoAspectRatio = mPrefs.getInt(Q3EPreference.pref_harm_r_autoAspectRatio, 1);
		if(autoAspectRatio > 0 && Q3EUtils.q3ei.IsIdTech4())
			SetProp_temp("harm_r_autoAspectRatio", autoAspectRatio);
		SelectRadioGroup(V.rg_r_autoAspectRatio, mPrefs.getInt(Q3EPreference.pref_harm_r_autoAspectRatio, 1));
		boolean skipIntro = mPrefs.getBoolean(Q3EPreference.pref_harm_skip_intro, false);
		V.skip_intro.setChecked(skipIntro);
		if (skipIntro && (Q3EUtils.q3ei.IsIdTech4() || Q3EUtils.q3ei.IsIdTech3()))
			SetCommand_temp("disconnect", false);
		boolean autoQuickLoad = mPrefs.getBoolean(Q3EPreference.pref_harm_auto_quick_load, false);
		V.auto_quick_load.setChecked(autoQuickLoad);
		if (autoQuickLoad && (Q3EUtils.q3ei.IsIdTech4() || Q3EUtils.q3ei.isRTCW || Q3EUtils.q3ei.isRealRTCW))
			SetParam_temp("loadGame", "QuickSave");
		boolean multithreading = mPrefs.getBoolean(Q3EPreference.pref_harm_multithreading, false);
		V.multithreading.setChecked(multithreading);
		V.rg_r_autoAspectRatio.setOnCheckedChangeListener(m_groupCheckChangeListener);
		int consoleHeightFrac = mPrefs.getInt(Q3EPreference.pref_harm_max_console_height_frac, 0);
		V.consoleHeightFracValue.setProgress(consoleHeightFrac);
		V.consoleHeightFracText.setText(GetConsoleHeightText(consoleHeightFrac));
		V.consoleHeightFracValue.setOnSeekBarChangeListener(m_seekListener);
		SelectRadioGroup(V.rg_depth_bits, Q3EPreference.DepthIndexByBits(mPrefs.getInt(Q3EPreference.pref_harm_depth_bit, Q3EGlobals.DEFAULT_DEPTH_BITS)));
		V.rg_depth_bits.setOnCheckedChangeListener(m_groupCheckChangeListener);

		V.edt_cmdline.setOnEditorActionListener(new TextView.OnEditorActionListener() {
			public boolean onEditorAction(TextView view, int id, KeyEvent ev)
			{
				if (ev.getKeyCode() == KeyEvent.KEYCODE_ENTER)
				{
					if (ev.getAction() == KeyEvent.ACTION_UP)
					{
						V.edt_path.requestFocus();
					}
					return true;
				}
				return false;
			}
		});
		boolean findDll = mPrefs.getBoolean(Q3EPreference.pref_harm_find_dll, false);
		V.find_dll.setChecked(findDll);
		V.launcher_tab1_edit_autoexec.setOnClickListener(m_buttonClickListener);
		V.launcher_tab1_edit_doomconfig.setOnClickListener(m_buttonClickListener);
		V.launcher_tab1_edit_cvar.setOnClickListener(m_buttonClickListener);
		V.launcher_tab1_command_record.setOnClickListener(m_buttonClickListener);
		V.launcher_tab1_create_shortcut.setOnClickListener(m_buttonClickListener);
		V.show_directory_helper.setOnClickListener(m_buttonClickListener);
		V.launcher_tab1_patch_resource.setOnClickListener(m_buttonClickListener);

		boolean userMod = mPrefs.getBoolean(Q3EUtils.q3ei.GetEnableModPreferenceKey(), false);
		V.fs_game_user.setChecked(userMod);
		String game = mPrefs.getString(Q3EUtils.q3ei.GetGameModPreferenceKey(), "");
		if (null == game)
			game = "";
		GameManager.GameProp prop = m_gameManager.ChangeGameMod(game, userMod);
		SelectRadioGroup(GetGameModRadioGroup(), prop.index);
		UpdateUserGame(userMod);
		V.edt_fs_game.setText(mPrefs.getString(Q3EUtils.q3ei.GetGameUserModPreferenceKey(), ""));
		V.fs_game_user.setOnCheckedChangeListener(m_checkboxChangeListener);
		for(RadioGroup rg : groupRadios.values())
		{
			rg.setOnCheckedChangeListener(m_groupCheckChangeListener);
		}
		V.edt_fs_game.addTextChangedListener(new TextWatcher() {
			public void onTextChanged(CharSequence s, int start, int before, int count)
			{
				if (V.fs_game_user.isChecked())
					SetGameModToCommand(s.toString());
			}

			public void beforeTextChanged(CharSequence s, int start, int count, int after)
			{
			}

			public void afterTextChanged(Editable s)
			{
				SharedPreferences.Editor editor = PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit();
				editor.putString(Q3EUtils.q3ei.GetGameUserModPreferenceKey(), s.toString());
				if (V.fs_game_user.isChecked())
					editor.putString(Q3EUtils.q3ei.GetGameModPreferenceKey(), s.toString());
				editor.commit();
			}
		});
		V.launcher_tab1_game_lib_button.setOnClickListener(m_buttonClickListener);
		V.launcher_tab1_game_mod_button.setOnClickListener(m_buttonClickListener);
		V.edt_harm_r_specularExponent.setText(Q3EPreference.GetStringFromFloat(mPrefs, Q3EPreference.pref_harm_r_specularExponent, 3.0f));
		V.edt_harm_r_specularExponentBlinnPhong.setText(Q3EPreference.GetStringFromFloat(mPrefs, Q3EPreference.pref_harm_r_specularExponentBlinnPhong, 12.0f));
		V.edt_harm_r_specularExponentPBR.setText(Q3EPreference.GetStringFromFloat(mPrefs, Q3EPreference.pref_harm_r_specularExponentPBR, 5.0f));
		V.edt_harm_r_ambientLightingBrightness.setText(Q3EPreference.GetStringFromFloat(mPrefs, Q3EPreference.pref_harm_r_ambientLightingBrightness, 1.0f));
		V.edt_harm_r_maxFps.setText(Q3EPreference.GetStringFromInt(mPrefs, Q3EPreference.pref_harm_r_maxFps, 0));

		Runnable customResChanged = new Runnable() {
			@Override
			public void run() {
				UpdateResolutionText();
			}
		};
		V.res_x.setText(mPrefs.getString(Q3EPreference.pref_resx, "" + Q3EGlobals.SCREEN_WIDTH));
		V.res_y.setText(mPrefs.getString(Q3EPreference.pref_resy, "" + Q3EGlobals.SCREEN_HEIGHT));
		V.res_x.addTextChangedListener(new SavePreferenceTextWatcher(Q3EPreference.pref_resx, "" + Q3EGlobals.SCREEN_WIDTH, customResChanged));
		V.res_y.addTextChangedListener(new SavePreferenceTextWatcher(Q3EPreference.pref_resy, "" + Q3EGlobals.SCREEN_HEIGHT, customResChanged));
		V.launcher_tab1_game_data_chooser_button.setOnClickListener(m_buttonClickListener);
		V.onscreen_button_setting.setOnClickListener(m_buttonClickListener);
		V.setup_onscreen_button_theme.setOnClickListener(m_buttonClickListener);

		// Quake2
		SetupUI_Quake2();

		// DOOM 3 BFG
		SetupUI_Doom3BFG();

		// RealRTCW
		SetupUI_RealRTCW();

		// ETW
		SetupUI_ETW();

		// GZDOOM
		SetupUI_GZDOOM();

		// The Dark Mod
		SetupUI_TDM();

		// FTEQW
		SetupUI_FTEQW();

		//DIII4A-specific
		SetupCommandTextWatcher(true);
		V.edt_harm_r_specularExponent.addTextChangedListener(new SaveFloatPreferenceTextWatcher("harm_r_specularExponent", Q3EPreference.pref_harm_r_specularExponent, 3.0f));
		V.edt_harm_r_specularExponentBlinnPhong.addTextChangedListener(new SaveFloatPreferenceTextWatcher("harm_r_specularExponentBlinnPhong", Q3EPreference.pref_harm_r_specularExponentBlinnPhong, 12.0f));
		V.edt_harm_r_specularExponentPBR.addTextChangedListener(new SaveFloatPreferenceTextWatcher("harm_r_specularExponentPBR", Q3EPreference.pref_harm_r_specularExponentPBR, 5.0f));
		V.edt_harm_r_ambientLightingBrightness.addTextChangedListener(new SaveFloatPreferenceTextWatcher("harm_r_ambientLightingBrightness", Q3EPreference.pref_harm_r_ambientLightingBrightness, 1.0f));
		V.edt_harm_r_maxFps.addTextChangedListener(new TextWatcher() {
			public void onTextChanged(CharSequence s, int start, int before, int count)
			{
				if(Q3EUtils.q3ei.IsIdTech4())
					SetProp("r_maxFps", s);
			}

			public void beforeTextChanged(CharSequence s, int start, int count, int after) { }

			public void afterTextChanged(Editable s)
			{
				String value = s.length() == 0 ? "0" : s.toString();
				Q3EPreference.SetIntFromString(GameLauncher.this, Q3EPreference.pref_harm_r_maxFps, value, 0);
			}
		});
		V.usedxt.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.useetc1.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.useetc1cache.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.nolight.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.image_useetc2.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.smoothjoy.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.launcher_tab2_joystick_unfixed.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.launcher_tab2_joystick_visible.setOnItemSelectedListener(m_itemSelectedListener);
		V.edt_path.addTextChangedListener(new SavePreferenceTextWatcher(Q3EPreference.pref_datapath, default_gamedata, new Runnable() {
			@Override
			public void run() {
				Q3EUtils.q3ei.datadir = V.edt_path.getText().toString();
			}
		}));
		V.edt_mouse.addTextChangedListener(new SavePreferenceTextWatcher(Q3EPreference.pref_eventdev, "/dev/input/event???"));
		V.rg_curpos.setOnCheckedChangeListener(m_groupCheckChangeListener);
		V.secfinglmb.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.mapvol.setOnCheckedChangeListener(m_checkboxChangeListener);
		UpdateMapVol(V.mapvol.isChecked());
		V.launcher_tab2_volume_up_map_config_keys.setOnItemSelectedListener(m_spinnerItemSelectedListener);
		V.launcher_tab2_volume_down_map_config_keys.setOnItemSelectedListener(m_spinnerItemSelectedListener);
		V.launcher_tab2_enable_gyro.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.launcher_tab2_gyro_x_axis_sens.setText(Q3EPreference.GetStringFromFloat(mPrefs, Q3EPreference.pref_harm_view_motion_gyro_x_axis_sens, Q3EControlView.GYROSCOPE_X_AXIS_SENS));
		V.launcher_tab2_gyro_y_axis_sens.setText(Q3EPreference.GetStringFromFloat(mPrefs, Q3EPreference.pref_harm_view_motion_gyro_y_axis_sens, Q3EControlView.GYROSCOPE_Y_AXIS_SENS));
		UpdateEnableGyro(V.launcher_tab2_enable_gyro.isChecked());
		V.launcher_tab2_gyro_x_axis_sens.addTextChangedListener(new TextWatcher() {
			public void onTextChanged(CharSequence s, int start, int before, int count)
			{
			}

			public void beforeTextChanged(CharSequence s, int start, int count, int after)
			{
			}

			public void afterTextChanged(Editable s)
			{
				String value = s.length() == 0 ? "" + Q3EControlView.GYROSCOPE_X_AXIS_SENS : s.toString();
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putFloat(Q3EPreference.pref_harm_view_motion_gyro_x_axis_sens, Q3EUtils.parseFloat_s(value, Q3EControlView.GYROSCOPE_Y_AXIS_SENS))
						.commit();
			}
		});
		V.launcher_tab2_gyro_y_axis_sens.addTextChangedListener(new TextWatcher() {
			public void onTextChanged(CharSequence s, int start, int before, int count)
			{
			}

			public void beforeTextChanged(CharSequence s, int start, int count, int after)
			{
			}

			public void afterTextChanged(Editable s)
			{
				String value = s.length() == 0 ? "" + Q3EControlView.GYROSCOPE_Y_AXIS_SENS : s.toString();
				PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
						.putFloat(Q3EPreference.pref_harm_view_motion_gyro_y_axis_sens, Q3EUtils.parseFloat_s(value, Q3EControlView.GYROSCOPE_Y_AXIS_SENS))
						.commit();
			}
		});
		V.auto_quick_load.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.skip_intro.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.multithreading.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.find_dll.setOnCheckedChangeListener(m_checkboxChangeListener);
//		V.scale_by_screen_area.setOnCheckedChangeListener(m_checkboxChangeListener);
//		V.scale_by_screen_area.setChecked(mPrefs.getBoolean(Q3EPreference.pref_harm_scale_by_screen_area, false));
		boolean useOpenAL = mPrefs.getBoolean(Q3EPreference.pref_harm_s_useOpenAL, true);
		V.cb_s_useOpenAL.setChecked(useOpenAL);
		V.cb_s_useEAXReverb.setChecked(mPrefs.getBoolean(Q3EPreference.pref_harm_s_useEAXReverb, true));
		V.cb_s_useOpenAL.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.cb_s_useEAXReverb.setOnCheckedChangeListener(m_checkboxChangeListener);
		if(!useOpenAL)
		{
			V.cb_s_useEAXReverb.setChecked(false);
			V.cb_s_useEAXReverb.setEnabled(false);
		}
		boolean readonlyCommand = mPrefs.getBoolean(PreferenceKey.READONLY_COMMAND, false);
		V.readonly_command.setChecked(!readonlyCommand);
		SetupCommandLine(readonlyCommand);
		V.readonly_command.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.cb_stencilShadowTranslucent.setChecked(mPrefs.getBoolean(Q3EPreference.pref_harm_r_stencilShadowTranslucent, false));
		V.cb_stencilShadowTranslucent.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.edt_harm_r_stencilShadowAlpha.setText(Q3EPreference.GetStringFromFloat(mPrefs, Q3EPreference.pref_harm_r_stencilShadowAlpha, 1.0f));
		V.edt_harm_r_stencilShadowAlpha.addTextChangedListener(new SaveFloatPreferenceTextWatcher("harm_r_stencilShadowAlpha", Q3EPreference.pref_harm_r_stencilShadowAlpha, 1.0f));
		V.edt_harm_r_shadowMapAlpha.setText(Q3EPreference.GetStringFromFloat(mPrefs, Q3EPreference.pref_harm_r_shadowMapAlpha, 1.0f));
		V.edt_harm_r_shadowMapAlpha.addTextChangedListener(new SaveFloatPreferenceTextWatcher("harm_r_shadowMapAlpha", Q3EPreference.pref_harm_r_shadowMapAlpha, 1.0f));

		V.cb_stencilShadowSoft.setChecked(mPrefs.getBoolean(Q3EPreference.pref_harm_r_stencilShadowSoft, false));
		V.cb_stencilShadowSoft.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.cb_stencilShadowCombine.setChecked(mPrefs.getBoolean(Q3EPreference.pref_harm_r_stencilShadowCombine, false));
		V.cb_stencilShadowCombine.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.cb_perforatedShadow.setChecked(mPrefs.getBoolean(Q3EPreference.pref_harm_r_shadowMapPerforatedShadow, false));
		V.cb_perforatedShadow.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.cb_useHighPrecision.setChecked(mPrefs.getBoolean(Q3EPreference.pref_harm_r_useHighPrecision, false));
		V.cb_useHighPrecision.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.cb_renderToolsMultithread.setChecked(mPrefs.getBoolean(Q3EPreference.pref_harm_r_renderToolsMultithread, false));
		V.cb_renderToolsMultithread.setOnCheckedChangeListener(m_checkboxChangeListener);

		boolean collapseMods = mPrefs.getBoolean(PreferenceKey.COLLAPSE_MODS, false);
		V.collapse_mods.setChecked(collapseMods);
		CollapseMods(collapseMods);
		V.collapse_mods.setOnCheckedChangeListener(m_checkboxChangeListener);

		SetupTempCommandLine(false);
		V.editable_temp_command.setOnCheckedChangeListener(m_checkboxChangeListener);
		V.edt_cmdline_temp.addTextChangedListener(new TextWatcher() {
			public void onTextChanged(CharSequence s, int start, int before, int count)
			{
				if (V.edt_cmdline_temp.isInputMethodTarget())
				{
					Q3EUtils.q3ei.start_temporary_extra_command = GetTempCmdText();
					UpdateTempCommand();
				}
			}

			public void beforeTextChanged(CharSequence s, int start, int count, int after) { }

			public void afterTextChanged(Editable s) { }
		});
	}

	private void SetupUI_Quake2()
	{
		SelectRadioGroup(V.yquake2_vid_renderer, "gles3".equals(GetProp("vid_renderer")) ? 1 : 0);
		V.yquake2_vid_renderer.setOnCheckedChangeListener(m_groupCheckChangeListener);
	}

	private void SetupUI_Doom3BFG()
	{
		int index = 0;
		String str = GetProp("harm_image_useCompression");
		if (str != null)
		{
			index = Q3EUtils.parseInt_s(str, 0);
		}
		SelectRadioGroup(V.doom3bfg_useCompression, index);
		V.doom3bfg_useCompression.setOnCheckedChangeListener(m_groupCheckChangeListener);

		V.doom3bfg_useCompressionCache.setChecked(getProp("harm_image_useCompressionCache", false));
		V.doom3bfg_useCompressionCache.setOnCheckedChangeListener(m_checkboxChangeListener);

		V.doom3bfg_useMediumPrecision.setChecked(getProp("harm_r_useMediumPrecision", false));
		V.doom3bfg_useMediumPrecision.setOnCheckedChangeListener(m_checkboxChangeListener);

		str = PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).getString(Q3EPreference.pref_harm_d3bfg_rendererBackend, "OpenGL");
		index = "Vulkan".equalsIgnoreCase(str) ? 1 : 0;
		SelectRadioGroup(V.doom3bfg_rendererBackend, index);
		V.doom3bfg_rendererBackend.setOnCheckedChangeListener(m_groupCheckChangeListener);
	}

	private void SetupUI_TDM()
	{
		V.tdm_useMediumPrecision.setChecked(getProp("harm_r_useMediumPrecision", false));
		V.tdm_useMediumPrecision.setOnCheckedChangeListener(m_checkboxChangeListener);
	}

	private void SetupUI_RealRTCW()
	{
		int index = 0;
		String str = GetProp("cg_shadows");
		if (str != null)
		{
			index = Q3EUtils.parseInt_s(str, 1);
		}
		SelectRadioGroup(V.realrtcw_shadows, index);
		V.realrtcw_shadows.setOnCheckedChangeListener(m_groupCheckChangeListener);

		V.realrtcw_sv_cheats.setChecked(getProp("harm_sv_cheats", false));
		V.realrtcw_sv_cheats.setOnCheckedChangeListener(m_checkboxChangeListener);

		V.realrtcw_stencilShadowPersonal.setChecked(getProp("harm_r_stencilShadowPersonal", true));
		V.realrtcw_stencilShadowPersonal.setOnCheckedChangeListener(m_checkboxChangeListener);
	}

	private void SetupUI_ETW()
	{
		int index;
		String str;

		V.etw_omnibot_enable.setChecked(getProp("omnibot_enable", false));
		V.etw_omnibot_enable.setOnCheckedChangeListener(m_checkboxChangeListener);

		index = 0;
		str = GetProp("cg_shadows");
		if (str != null)
		{
			index = Q3EUtils.parseInt_s(str, 1);
		}
		SelectRadioGroup(V.etw_shadows, index);
		V.etw_shadows.setOnCheckedChangeListener(m_groupCheckChangeListener);

		V.etw_stencilShadowPersonal.setChecked(getProp("harm_r_stencilShadowPersonal", true));
		V.etw_stencilShadowPersonal.setOnCheckedChangeListener(m_checkboxChangeListener);

		V.etw_ui_disableAndroidMacro.setChecked(getProp("harm_ui_disableAndroidMacro", false));
		V.etw_ui_disableAndroidMacro.setOnCheckedChangeListener(m_checkboxChangeListener);
	}

	private void SetupUI_GZDOOM()
	{
		int index;
		String str;

		SharedPreferences mPrefs = PreferenceManager.getDefaultSharedPreferences(this);

		boolean load = mPrefs.getBoolean(Q3EPreference.pref_harm_gzdoom_load_lights_pk3, true);
		V.gzdoom_load_lights_pk3.setChecked(load);
		if (load && (Q3EUtils.q3ei.isDOOM))
			AddParam_temp("file", "lights.pk3");
		V.gzdoom_load_lights_pk3.setOnCheckedChangeListener(m_checkboxChangeListener);

		load = mPrefs.getBoolean(Q3EPreference.pref_harm_gzdoom_load_brightmaps_pk3, true);
		V.gzdoom_load_brightmaps_pk3.setChecked(load);
		if (load && (Q3EUtils.q3ei.isDOOM))
			AddParam_temp("file", "brightmaps.pk3");
		V.gzdoom_load_brightmaps_pk3.setOnCheckedChangeListener(m_checkboxChangeListener);

		/*List<String> file = GetParamList("file");
		V.gzdoom_load_lights_pk3.setChecked(null != file && file.contains("lights.pk3"));*/

		V.gzdoom_choose_extras_file.setOnClickListener(m_buttonClickListener);

		index = 2;
		str = GetPropPrefix(KidTechCommand.ARG_PREFIX_ALL, "vid_preferbackend");
		if (str != null)
		{
			index = Q3EUtils.parseInt_s(str, 2);
		}
		SelectRadioGroup(V.gzdoom_vid_preferbackend, index);
		V.gzdoom_vid_preferbackend.setOnCheckedChangeListener(m_groupCheckChangeListener);

		index = 0;
		str = GetPropPrefix(KidTechCommand.ARG_PREFIX_ALL, "harm_gl_es");
		if (str != null)
		{
			index = Q3EUtils.parseInt_s(str, 0);
			if(index > 0)
				index--;
		}
		SelectRadioGroup(V.gzdoom_gl_es, index);
		V.gzdoom_gl_es.setOnCheckedChangeListener(m_groupCheckChangeListener);

		index = 0;
		str = GetPropPrefix(KidTechCommand.ARG_PREFIX_ALL, "harm_gl_version");
		if (str != null)
		{
			index = Q3EUtils.parseInt_s(str, 0);
			index = Utility.ArrayIndexOf(Q3EGlobals.GZDOOM_GL_VERSIONS, index);
			if(index < 0)
				index = 0;
		}
		SelectRadioGroup(V.gzdoom_gl_version, index);
		V.gzdoom_gl_version.setOnCheckedChangeListener(m_groupCheckChangeListener);
	}

	private void SetupUI_FTEQW()
	{
		int index;
		String str;

		SharedPreferences mPrefs = PreferenceManager.getDefaultSharedPreferences(this);

		index = 1;
		str = GetPropPrefix(KidTechCommand.ARG_PREFIX_ALL, "vid_renderer");
		if (str != null)
		{
			index = "vk".equalsIgnoreCase(str) ? 0 : 1;
		}
		SelectRadioGroup(V.fteqw_vid_renderer, index);
		V.fteqw_vid_renderer.setOnCheckedChangeListener(m_groupCheckChangeListener);
	}

	private void AfterCreated()
	{
		try
		{
			Q3EAd.LoadAds(this);

			OpenUpdate();

			Intent intent = getIntent();
			if(null != intent)
			{
				Bundle extras = intent.getExtras();
				if(null != extras)
				{
					String intentGame = extras.getString("game");
					if(null != intentGame && !intentGame.isEmpty())
					{
						KLog.I("Launcher initial game: " + intentGame);
						ChangeGame(intentGame);
					}
				}
			}
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	@Override
    protected void onDestroy()
    {
        super.onDestroy();
        if (null != m_checkForUpdateFunc)
            m_checkForUpdateFunc.Reset();
		if (null != m_openSourceLicenseFunc)
			m_openSourceLicenseFunc.Reset();
    }

    public void start(View vw)
    {
        //k
        WritePreferences();

        if (null == m_startGameFunc)
            m_startGameFunc = new StartGameFunc(this, CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_START);
        Bundle bundle = new Bundle();
        bundle.putString("path", V.edt_path.getText().toString());
        m_startGameFunc.Start(bundle);
    }

    public void controls(View vw)
    {
        startActivity(new Intent(this, Q3EUiConfig.class));
    }

    //k
    public boolean getProp(String name, boolean defaultValueIfNotExists)
    {
        String val = GetProp(name);
        if (val != null && !val.trim().isEmpty())
            return "1".equals(val);
        return defaultValueIfNotExists;
    }

    private void SetProp(String name, Object val)
    {
		if(!LockCmdUpdate())
			return;
		SetCmdText(Q3EUtils.q3ei.GetGameCommandEngine(GetCmdText()).SetProp(name, val).toString());
        //SetCmdText(KidTech4Command.SetProp(GetCmdText(), name, val));
        UnlockCmdUpdate();
    }

    private String GetProp(String name)
    {
		return Q3EUtils.q3ei.GetGameCommandEngine(GetCmdText()).Prop(name);
		// return KidTech4Command.GetProp(GetCmdText(), name);
    }

    private void RemoveProp(String name)
    {
		if(!LockCmdUpdate())
			return;
		String orig = GetCmdText();
		String str = Q3EUtils.q3ei.GetGameCommandEngine(orig).RemoveProp(name).toString();
        if (!orig.equals(str))
            SetCmdText(str);
        UnlockCmdUpdate();
    }

    private boolean IsProp(String name)
    {
		return Q3EUtils.q3ei.GetGameCommandEngine(GetCmdText()).IsProp(name);
        // return KidTech4Command.IsProp(GetCmdText(), name);
    }

	private void SetPropPrefix(String prefix, String name, Object val)
	{
		if(!LockCmdUpdate())
			return;
		SetCmdText(new KidTechCommand(prefix, GetCmdText()).SetProp(name, val).toString());
		UnlockCmdUpdate();
	}

	private String GetPropPrefix(String prefix, String name)
	{
		return new KidTechCommand(prefix, GetCmdText()).Prop(name);
		// return KidTech4Command.GetProp(GetCmdText(), name);
	}

	private void RemovePropPrefix(String prefix, String name)
	{
		if(!LockCmdUpdate())
			return;
		String orig = GetCmdText();
		String str = new KidTechCommand(prefix, orig).RemoveProp(name).toString();
		if (!orig.equals(str))
			SetCmdText(str);
		UnlockCmdUpdate();
	}

    private void EditFile(String file, boolean findInHome)
    {
        if (null == m_editConfigFileFunc)
            m_editConfigFileFunc = new EditConfigFileFunc(this, CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_EDIT_CONFIG_FILE);

        Bundle bundle = new Bundle();
        String game = GetGameModFromCommand();
        if (game == null || game.isEmpty())
            game = Q3EUtils.q3ei.game_base;
		else
		{
			String str = m_gameManager.GetGameFileOfMod(game);
			if(null != str)
				game = str;
		}
		String path = KStr.AppendPath(V.edt_path.getText().toString(), Q3EUtils.q3ei.subdatadir);
		if(findInHome)
			path = KStr.AppendPath(path, Q3EUtils.q3ei.GetGameHomeDirectoryPath());
        bundle.putString("game", game);
		bundle.putString("path", path);
        bundle.putString("file", file);
        m_editConfigFileFunc.Start(bundle);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu)
    {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.activity_main, menu);

        if (ContextUtility.BuildIsDebug(this))
        {
            menu.findItem(R.id.main_menu_dev_menu).setVisible(true);
        }
        V.main_menu_game = menu.findItem(R.id.main_menu_game);
        V.main_menu_game.setTitle(Q3EUtils.q3ei.game_name);
		SubMenu subMenu = V.main_menu_game.getSubMenu();
		for(int i = 0; i < subMenu.size(); i++)
		{
			MenuItem item = subMenu.getItem(i);
			Drawable icon = item.getIcon();
			if(icon instanceof BitmapDrawable)
			{
				Bitmap bitmap = ((BitmapDrawable) icon).getBitmap();
				Bitmap scaledBitmap = Bitmap.createScaledBitmap(bitmap, 32, 32, true);
				item.setIcon(new BitmapDrawable(getResources(), scaledBitmap));
			}
		}
		return super.onCreateOptionsMenu(menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item)
    {
		int itemId = item.getItemId();
		if (itemId == R.id.main_menu_support_developer)
		{
			support(null);
			return true;
		}
		else if (itemId == R.id.main_menu_changes)
		{
			OpenChanges();
			return true;
		}
		else if (itemId == R.id.main_menu_source)
		{
			OpenAbout();
			return true;
		}
		else if (itemId == R.id.main_menu_help)
		{
			OpenHelp();
			return true;
		}
		else if (itemId == R.id.main_menu_settings)
		{
			OpenSettings();
			return true;
		}
		else if (itemId == R.id.main_menu_runtime_log)
		{
			OpenRuntimeLog();
			return true;
		}
		else if (itemId == R.id.main_menu_cvar_list)
		{
			OpenCvarListDetail();
			return true;
		}
		else if (itemId == R.id.main_menu_extract_resource)
		{
			OpenResourceFileDialog(true);
			return true;
		}
		else if (itemId == R.id.main_menu_save_settings)
		{
			WritePreferences();
			Toast.makeText(this, R.string.preferences_settings_saved, Toast.LENGTH_LONG).show();
			return true;
		}
		else if (itemId == R.id.main_menu_backup_settings)
		{
			RequestBackupPreferences();
			return true;
		}
		else if (itemId == R.id.main_menu_restore_settings)
		{
			RequestRestorePreferences();
			return true;
		}
		else if (itemId == R.id.main_menu_debug)
		{
			OpenDebugDialog();
			return true;
		}
		else if (itemId == R.id.main_menu_experimental)
		{
			OpenExperimentalDialog();
			return true;
		}
		else if (itemId == R.id.main_menu_test)
		{
			Test();
			return true;
		}
		else if (itemId == R.id.main_menu_show_preference)
		{
			ShowPreferenceDialog();
			return true;
		}
		else if (itemId == R.id.main_menu_debug_text_history)
		{
			ShowDebugTextHistoryDialog();
			return true;
		}
		else if (itemId == R.id.main_menu_gen_exception)
		{
			ThrowException();
			return true;
		}
		else if (itemId == R.id.main_menu_check_for_update)
		{
			OpenCheckForUpdateDialog();
			return true;
		}
		else if (itemId == R.id.main_menu_translators)
		{
			OpenTranslatorsDialog();
			return true;
		}
		else if (itemId == R.id.main_menu_shortcut)
		{
			OpenShortcutCreator();
			return true;
		}
		else if (itemId == R.id.main_menu_change_game)
		{
			OpenGameList();
			return true;
		}
/*		else if (itemId == R.id.main_menu_shortcut_command)
		{
			OpenShortcutWithCommandCreator();
			return true;
		}*/

		else if (itemId == R.id.main_menu_game_doom3)
		{
			ChangeGame(Q3EGlobals.GAME_DOOM3);
			return true;
		}
		else if (itemId == R.id.main_menu_game_quake4)
		{
			ChangeGame(Q3EGlobals.GAME_QUAKE4);
			return true;
		}
		else if (itemId == R.id.main_menu_game_prey)
		{
			ChangeGame(Q3EGlobals.GAME_PREY);
			return true;
		}
		else if (itemId == R.id.main_menu_game_quake1)
		{
			ChangeGame(Q3EGlobals.GAME_QUAKE1);
			return true;
		}
		else if (itemId == R.id.main_menu_game_quake2)
		{
			ChangeGame(Q3EGlobals.GAME_QUAKE2);
			return true;
		}
		else if (itemId == R.id.main_menu_game_quake3)
		{
			ChangeGame(Q3EGlobals.GAME_QUAKE3);
			return true;
		}
		else if (itemId == R.id.main_menu_game_rtcw)
		{
			ChangeGame(Q3EGlobals.GAME_RTCW);
			return true;
		}
		else if (itemId == R.id.main_menu_game_tdm)
		{
			ChangeGame(Q3EGlobals.GAME_TDM);
			return true;
		}
		else if (itemId == R.id.main_menu_game_doom3bfg)
		{
			ChangeGame(Q3EGlobals.GAME_DOOM3BFG);
			return true;
		}
		else if (itemId == R.id.main_menu_game_doom)
		{
			ChangeGame(Q3EGlobals.GAME_GZDOOM);
			return true;
		}
		else if (itemId == R.id.main_menu_game_etw)
		{
			ChangeGame(Q3EGlobals.GAME_ETW);
			return true;
		}
		else if (itemId == R.id.main_menu_game_realrtcw)
		{
			ChangeGame(Q3EGlobals.GAME_REALRTCW);
			return true;
		}
		else if (itemId == R.id.main_menu_game_fteqw)
		{
			ChangeGame(Q3EGlobals.GAME_FTEQW);
			return true;
		}
		else if (itemId == android.R.id.home)
		{
			ChangeGame();
			return true;
		}
		/*else if (itemId == R.id.main_menu_move_game_data)
		{
			MoveGameDataToAppPrivateDirectory();
			return true;
		}*/
		return super.onOptionsItemSelected(item);
	}

    private void OpenChanges()
    {
        ContextUtility.OpenMessageDialog(this, Q3ELang.tr(this, R.string.changes), TextHelper.GetChangesText());
    }

    private void OpenAbout()
    {
    	Object[] args = { null };
		AlertDialog dialog = ContextUtility.OpenMessageDialog(this, Q3ELang.tr(this, R.string.about) + " " + Constants.CONST_APP_NAME + "(" + Constants.CONST_CODE + ")", TextHelper.GetAboutText(this), new Runnable() {
			@Override
			public void run()
			{
				AlertDialog.Builder builder = (AlertDialog.Builder)args[0];
				builder.setNeutralButton(R.string.license, new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which)
					{
						if (null == m_openSourceLicenseFunc)
							m_openSourceLicenseFunc = new OpenSourceLicenseFunc(GameLauncher.this);
						m_openSourceLicenseFunc.Start(new Bundle());
					}
				});
				builder.setNegativeButton(R.string.extract_source, new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which)
					{
						if (null == m_extractSourceFunc)
							m_extractSourceFunc = new ExtractSourceFunc(GameLauncher.this, CONST_RESULT_CODE_REQUEST_EXTRACT_SOURCE);
						m_extractSourceFunc.Start(new Bundle());
					}
				});
			}
		}, args);
		dialog.show();
	}

	private void OpenRuntimeErrorLog()
	{
		String path = Q3EUtils.q3ei.GetGameDataDirectoryPath("stderr.txt");
		String text = Q3EUtils.file_get_contents(path);

		AlertDialog.Builder builder = ContextUtility.CreateMessageDialogBuilder(this, Q3ELang.tr(this, R.string.last_runtime_log) + ": stderr.txt", text);
		builder.setNeutralButton("stdout.txt", new AlertDialog.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int which)
			{
				OpenRuntimeLog();
				dialog.dismiss();
			}
		});
		builder.create().show();
	}

    private void OpenRuntimeLog()
    {
		String path = Q3EUtils.q3ei.GetGameDataDirectoryPath("stdout.txt");
		String text = Q3EUtils.file_get_contents(path);

		AlertDialog.Builder builder = ContextUtility.CreateMessageDialogBuilder(this, Q3ELang.tr(this, R.string.last_runtime_log), text);
		builder.setNeutralButton("stderr.txt", new AlertDialog.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int which)
			{
				OpenRuntimeErrorLog();
				dialog.dismiss();
			}
		});
		builder.create().show();

		//Toast.makeText(this, Q3ELang.tr(this, R.string.file_can_not_access) + path, Toast.LENGTH_LONG).show();
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, String[] permissions, int[] grantResults)
    {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        List<String> list = null;
        for (int i = 0; i < permissions.length; i++)
        {
            if (grantResults[i] != PackageManager.PERMISSION_GRANTED)
            {
                if (list == null)
                    list = new ArrayList<>();
                list.add(permissions[i]);
            }
        }

        HandleGrantPermissionResult(requestCode, list);
    }

    private void OpenFolderChooser()
    {
        if (null == m_chooseGameFolderFunc)
            m_chooseGameFolderFunc = new ChooseGameFolderFunc(this, CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_FOLDER, CONST_RESULT_CODE_ACCESS_ANDROID_DATA, new Runnable()
            {
                @Override
                public void run()
                {
                    V.edt_path.setText(m_chooseGameFolderFunc.GetResult());
					OpenSuggestGameWorkingDirectory(V.edt_path.getText().toString());
                }
            });
        Bundle bundle = new Bundle();
        bundle.putString("path", V.edt_path.getText().toString());
        m_chooseGameFolderFunc.Start(bundle);
    }

	private void SetupExtrasFiles(String extrasFiles)
	{
		if(":".equals(extrasFiles))
		{
			RemoveParamPrefix(KidTechCommand.ARG_PREFIX_ALL, "file");
			RemoveParamPrefix(KidTechCommand.ARG_PREFIX_ALL, "deh");
			RemoveParamPrefix(KidTechCommand.ARG_PREFIX_ALL, "bex");
		}
		else
		{
			String files = extrasFiles.substring(1);
			String[] split = files.split(ChooseExtrasFileFunc.FILE_SEP);
			List<String> file = new ArrayList<>();
			List<String> deh = new ArrayList<>();
			List<String> bex = new ArrayList<>();

			for (String s : split)
			{
				if(s.toLowerCase().endsWith(".deh"))
					deh.add(s);
				else if(s.toLowerCase().endsWith(".bex"))
					bex.add(s);
				else
					file.add(s);
			}

			// if(V.gzdoom_load_lights_pk3.isChecked() && !file.contains("lights.pk3")) file.add("light3.pk3");

			RemoveParamPrefix(KidTechCommand.ARG_PREFIX_ALL, "file");
			RemoveParamPrefix(KidTechCommand.ARG_PREFIX_ALL, "deh");
			RemoveParamPrefix(KidTechCommand.ARG_PREFIX_ALL, "bex");

			if(!file.isEmpty())
				SetParamList("file", file);
			if(!deh.isEmpty())
				SetParamList("deh", deh);
			if(!bex.isEmpty())
				SetParamList("bex", bex);
		}
	}

	private void OpenExtrasFileChooser()
	{
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(this);
		String preferenceKey = Q3EUtils.q3ei.GetGameModPreferenceKey();

		if (null == m_chooseExtrasFileFunc)
			m_chooseExtrasFileFunc = new ChooseExtrasFileFunc(this, CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_EXTRAS_FILE);

		m_chooseExtrasFileFunc.SetCallback(new Runnable() {
			@Override
			public void run()
			{
				String extrasFiles = m_chooseExtrasFileFunc.GetResult();
				SetupExtrasFiles(extrasFiles);
			}
		});

		Bundle bundle = new Bundle();
		String path = KStr.AppendPath(preference.getString(Q3EPreference.pref_datapath, default_gamedata), Q3EUtils.q3ei.subdatadir, Q3EUtils.q3ei.GetGameModSubDirectory());
		bundle.putString("mod", preference.getString(preferenceKey, ""));
		bundle.putString("path", path);
		if(Q3EUtils.q3ei.isDOOM)
			bundle.putString("file", GetParamPrefix(KidTechCommand.ARG_PREFIX_ALL, "file") + " " + GetParamPrefix(KidTechCommand.ARG_PREFIX_ALL, "deh") + " " + GetParamPrefix(KidTechCommand.ARG_PREFIX_ALL, "bex"));
		m_chooseExtrasFileFunc.Start(bundle);
	}

    private void WritePreferences()
    {
        SharedPreferences.Editor mEdtr = PreferenceManager.getDefaultSharedPreferences(this).edit();
        mEdtr.putString(Q3EUtils.q3ei.GetGameCommandPreferenceKey(), GetCmdText());
        mEdtr.putString(Q3EPreference.pref_eventdev, V.edt_mouse.getText().toString());
        mEdtr.putString(Q3EPreference.pref_datapath, V.edt_path.getText().toString());
        mEdtr.putBoolean(Q3EPreference.pref_hideonscr, V.hideonscr.isChecked());
        mEdtr.putBoolean(Q3EPreference.pref_harm_using_mouse, V.using_mouse.isChecked());
        //k mEdtr.putBoolean(Q3EUtils.pref_32bit, true);
        int index = GetRadioGroupSelectIndex(V.rg_color_bits) - 1;
        mEdtr.putBoolean(Q3EPreference.pref_32bit, index == -1);
        mEdtr.putInt(Q3EPreference.pref_harm_16bit, index);
        mEdtr.putInt(Q3EPreference.pref_harm_r_harmclearvertexbuffer, GetRadioGroupSelectIndex(V.r_harmclearvertexbuffer));
        mEdtr.putString(Q3EPreference.pref_harm_r_lightingModel, "" + ((GetRadioGroupSelectIndex(V.rg_harm_r_lightingModel) + 1) % V.rg_harm_r_lightingModel.getChildCount()));
        mEdtr.putFloat(Q3EPreference.pref_harm_r_specularExponent, Q3EUtils.parseFloat_s(V.edt_harm_r_specularExponent.getText().toString(), 3.0f));
		mEdtr.putFloat(Q3EPreference.pref_harm_r_specularExponentBlinnPhong, Q3EUtils.parseFloat_s(V.edt_harm_r_specularExponentBlinnPhong.getText().toString(), 12.0f));
		mEdtr.putFloat(Q3EPreference.pref_harm_r_specularExponentPBR, Q3EUtils.parseFloat_s(V.edt_harm_r_specularExponentPBR.getText().toString(), 5.0f));
		mEdtr.putFloat(Q3EPreference.pref_harm_r_ambientLightingBrightness, Q3EUtils.parseFloat_s(V.edt_harm_r_ambientLightingBrightness.getText().toString(), 1.0f));
        mEdtr.putString(Q3EPreference.pref_harm_s_driver, GetRadioGroupSelectIndex(V.rg_s_driver) == 1 ? "OpenSLES" : "AudioTrack");
		mEdtr.putInt(Q3EPreference.pref_harm_r_maxFps, Q3EUtils.parseInt_s(V.edt_harm_r_maxFps.getText().toString(), 0));
		mEdtr.putBoolean(Q3EPreference.pref_harm_r_useShadowMapping, GetRadioGroupSelectIndex(V.rg_harm_r_shadow) == 1);
		mEdtr.putInt(Q3EPreference.pref_harm_opengl, GetRadioGroupSelectIndex(V.rg_opengl) == 1 ? Q3EGLConstants.OPENGLES30 : Q3EGLConstants.OPENGLES20);
		mEdtr.putInt(Q3EPreference.pref_harm_depth_bit, Q3EPreference.DepthBitsByIndex(GetRadioGroupSelectIndex(V.rg_depth_bits)));

        mEdtr.putBoolean(Q3EPreference.pref_mapvol, V.mapvol.isChecked());
        mEdtr.putBoolean(Q3EPreference.pref_analog, V.smoothjoy.isChecked());
        mEdtr.putBoolean(Q3EPreference.pref_2fingerlmb, V.secfinglmb.isChecked());
        mEdtr.putBoolean(Q3EPreference.pref_detectmouse, V.detectmouse.isChecked());
        mEdtr.putInt(Q3EPreference.pref_mousepos, GetRadioGroupSelectIndex(V.rg_curpos));
		mEdtr.putInt(Q3EPreference.pref_scrres_scheme, GetRadioGroupSelectIndex(V.rg_scrres));
        mEdtr.putInt(Q3EPreference.pref_msaa, GetRadioGroupSelectIndex(V.rg_msaa));
        mEdtr.putString(Q3EPreference.pref_resx, V.res_x.getText().toString());
        mEdtr.putString(Q3EPreference.pref_resy, V.res_y.getText().toString());
        mEdtr.putBoolean(Q3EPreference.pref_useetc1cache, V.useetc1cache.isChecked());
        mEdtr.putBoolean(Q3EPreference.pref_useetc1, V.useetc1.isChecked());
        mEdtr.putBoolean(Q3EPreference.pref_usedxt, V.usedxt.isChecked());
        mEdtr.putBoolean(Q3EPreference.pref_nolight, V.nolight.isChecked());
		mEdtr.putBoolean(Q3EPreference.pref_harm_image_useetc2, V.image_useetc2.isChecked());
        mEdtr.putBoolean(Q3EUtils.q3ei.GetEnableModPreferenceKey(), V.fs_game_user.isChecked());
        mEdtr.putString(Q3EPreference.pref_harm_game, Q3EUtils.q3ei.game);
        mEdtr.putBoolean(Q3EPreference.pref_harm_view_motion_control_gyro, V.launcher_tab2_enable_gyro.isChecked());
        mEdtr.putFloat(Q3EPreference.pref_harm_view_motion_gyro_x_axis_sens, Q3EUtils.parseFloat_s(V.launcher_tab2_gyro_x_axis_sens.getText().toString(), Q3EControlView.GYROSCOPE_X_AXIS_SENS));
        mEdtr.putFloat(Q3EPreference.pref_harm_view_motion_gyro_y_axis_sens, Q3EUtils.parseFloat_s(V.launcher_tab2_gyro_y_axis_sens.getText().toString(), Q3EControlView.GYROSCOPE_Y_AXIS_SENS));
        mEdtr.putBoolean(Q3EPreference.pref_harm_auto_quick_load, V.auto_quick_load.isChecked());
		mEdtr.putBoolean(Q3EPreference.pref_harm_skip_intro, V.skip_intro.isChecked());
        mEdtr.putBoolean(Q3EPreference.pref_harm_multithreading, V.multithreading.isChecked());
        mEdtr.putBoolean(Q3EPreference.pref_harm_joystick_unfixed, V.launcher_tab2_joystick_unfixed.isChecked());
		mEdtr.putInt(Q3EPreference.pref_harm_joystick_visible, getResources().getIntArray(R.array.joystick_visible_mode_values)[V.launcher_tab2_joystick_visible.getSelectedItemPosition()]);
        mEdtr.putBoolean(Q3EPreference.pref_harm_find_dll, V.find_dll.isChecked());
//		mEdtr.putBoolean(Q3EPreference.pref_harm_scale_by_screen_area, V.scale_by_screen_area.isChecked());
		mEdtr.putBoolean(Q3EPreference.pref_harm_s_useOpenAL, V.cb_s_useOpenAL.isChecked());
		mEdtr.putBoolean(Q3EPreference.pref_harm_s_useEAXReverb, V.cb_s_useEAXReverb.isChecked());
		mEdtr.putBoolean(PreferenceKey.READONLY_COMMAND, !V.readonly_command.isChecked());
		mEdtr.putBoolean(Q3EPreference.pref_harm_r_stencilShadowTranslucent, V.cb_stencilShadowTranslucent.isChecked());
		mEdtr.putFloat(Q3EPreference.pref_harm_r_stencilShadowAlpha, Q3EUtils.parseFloat_s(V.edt_harm_r_stencilShadowAlpha.getText().toString(), 1.0f));
		mEdtr.putFloat(Q3EPreference.pref_harm_r_shadowMapAlpha, Q3EUtils.parseFloat_s(V.edt_harm_r_shadowMapAlpha.getText().toString(), 1.0f));
		mEdtr.putBoolean(Q3EPreference.pref_harm_r_stencilShadowSoft, V.cb_stencilShadowSoft.isChecked());
		mEdtr.putBoolean(Q3EPreference.pref_harm_r_stencilShadowCombine, V.cb_stencilShadowCombine.isChecked());
		mEdtr.putBoolean(Q3EPreference.pref_harm_r_shadowMapPerforatedShadow, V.cb_perforatedShadow.isChecked());
		mEdtr.putBoolean(Q3EPreference.pref_harm_r_useHighPrecision, V.cb_useHighPrecision.isChecked());
		mEdtr.putBoolean(Q3EPreference.pref_harm_r_renderToolsMultithread, V.cb_renderToolsMultithread.isChecked());
		mEdtr.putInt(Q3EPreference.pref_harm_r_autoAspectRatio, GetRadioGroupSelectIndex(V.rg_r_autoAspectRatio));
		mEdtr.putBoolean(PreferenceKey.COLLAPSE_MODS, V.collapse_mods.isChecked());

		mEdtr.putBoolean(Q3EPreference.pref_harm_gzdoom_load_lights_pk3, V.gzdoom_load_lights_pk3.isChecked());
		mEdtr.putBoolean(Q3EPreference.pref_harm_gzdoom_load_brightmaps_pk3, V.gzdoom_load_brightmaps_pk3.isChecked());
		mEdtr.putInt(Q3EPreference.pref_harm_max_console_height_frac, V.consoleHeightFracValue.getProgress());
		mEdtr.putString(Q3EUtils.q3ei.GetGameUserModPreferenceKey(), V.edt_fs_game.getText().toString());
		if(Q3EUtils.q3ei.isD3BFG)
		{
			index = GetRadioGroupSelectIndex(V.doom3bfg_rendererBackend);
			String rb = index == 1 ? "Vulkan" : "OpenGL";
			mEdtr.putString(Q3EPreference.pref_harm_d3bfg_rendererBackend, rb);
		}
        mEdtr.commit();
    }

    private void OpenHelp()
    {
        ContextUtility.OpenMessageDialog(this, Q3ELang.tr(this, R.string.help), TextHelper.GetHelpText());
    }

    private void OpenUpdate()
    {
        if (IsUpdateRelease())
		{
			Object[] args = new Object[1];
			Runnable callback = new Runnable() {
				@Override
				public void run()
				{
					AlertDialog.Builder builder = (AlertDialog.Builder)args[0];
					builder.setOnDismissListener(new DialogInterface.OnDismissListener() {
						@Override
						public void onDismiss(DialogInterface dialog)
						{
							OpenUpdateTips();
						}
					});
				}
			};
			ContextUtility.OpenMessageDialog(this, Q3ELang.tr(this, R.string.update_) + Constants.CONST_APP_NAME + "(" + Constants.CONST_CODE + ")", TextHelper.GetUpdateText(this), callback, args);
		}
		else
			OpenUpdateTips();
    }

    private boolean IsUpdateRelease()
    {
        final String UPDATE_RELEASE = "UPDATE_RELEASE";
        SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(this);
        int r = pref.getInt(UPDATE_RELEASE, 0);
        if (r == Constants.CONST_UPDATE_RELEASE)
            return false;
        pref.edit().putInt(UPDATE_RELEASE, Constants.CONST_UPDATE_RELEASE).commit();
        return true;
    }

	private static class TipState
	{
		public final String name;
		public final int    version;
		public       int    checked;

		public TipState(String name, int version, int checked)
		{
			this.name = name;
			this.version = version;
			this.checked = checked;
		}

		public TipState(String str)
		{
			String[] part = str.trim().split(" ");
			name = part[0];
			version = Integer.parseInt(part[1]);
			checked = Integer.parseInt(part[2]);
		}

		public boolean NeedCheck(String n)
		{
			return name.equals(n) && checked == 0 && Constants.CONST_UPDATE_RELEASE >= version;
		}

		public String ToString()
		{
			return name + " " + version + " " + checked;
		}
	}

	private void OpenUpdateTips()
	{
		Map<String, Integer> defaultTips = new LinkedHashMap<>();
		defaultTips.put("STANDALONE_DIRECTORY", 57);

		OpenUpdateTipsDialog(defaultTips, null);
	}

	private void OpenUpdateTipsDialog(Map<String, Integer> defaultTips, Set<String> ignore)
	{
		final String UPDATE_TIPS = "UPDATE_TIPS";
		SharedPreferences pref = PreferenceManager.getDefaultSharedPreferences(this);
		Set<String> stateSet = pref.getStringSet(UPDATE_TIPS, new TreeSet<>());
		Set<String> writeSet = new TreeSet<>(stateSet);

		Set<String> handled = new HashSet<>();
		if(null != ignore)
			handled.addAll(ignore);

		for(Map.Entry<String, Integer> def : defaultTips.entrySet())
		{
			if(handled.contains(def.getKey()))
				continue;

			handled.add(def.getKey());

			TipState tmp = null;
			for(String state : writeSet)
			{
				TipState tt = new TipState(state);
				if(def.getKey().equals(tt.name))
				{
					tmp = tt;
					writeSet.remove(state);
					break;
				}
			}
			final TipState t = null == tmp ? new TipState(def.getKey(), def.getValue(), 0) : tmp;

			if(t.NeedCheck("STANDALONE_DIRECTORY") || !pref.contains(Q3EPreference.GAME_STANDALONE_DIRECTORY))
			{
				String Endl = TextHelper.GetDialogMessageEndl();
				String message = Q3ELang.tr(GameLauncher.this, R.string.idtech4amm_requires_enable_game_standalone_directory_since_version_57) + Endl
						+ Q3ELang.tr(GameLauncher.this, R.string.you_can_also_disable_it_like_older_version) + Endl
						+ Q3ELang.tr(GameLauncher.this, R.string.you_can_also_change_it_manually_on_launcher_settings) + Endl
						+ Q3ELang.tr(GameLauncher.this, R.string.you_can_view_all_support_games_data_directory_path_by_tips_button_above_chooser_button_in_launcher)
						;

				AlertDialog.Builder builder = ContextUtility.CreateMessageDialogBuilder(this, Q3ELang.tr(GameLauncher.this, R.string.enable_game_standalone_directory), TextHelper.GetDialogMessage(message));
				builder.setPositiveButton(R.string.enable, new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which)
					{
						t.checked = 1;
						writeSet.add(t.ToString());
						pref.edit().putBoolean(Q3EPreference.GAME_STANDALONE_DIRECTORY, true)
								.putStringSet(UPDATE_TIPS, writeSet)
								.commit();
					}
				});
				builder.setNeutralButton(R.string.ignore, new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which)
					{
						t.checked = 3;
						writeSet.add(t.ToString());
						pref.edit().putStringSet(UPDATE_TIPS, writeSet).commit();
					}
				});
				builder.setNegativeButton(R.string.disable, new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which)
					{
						t.checked = 2;
						writeSet.add(t.ToString());
						pref.edit().putBoolean(Q3EPreference.GAME_STANDALONE_DIRECTORY, false)
								.putStringSet(UPDATE_TIPS, writeSet)
								.commit();
					}
				});
				builder.setOnDismissListener(new DialogInterface.OnDismissListener() {
					@Override
					public void onDismiss(DialogInterface dialog)
					{
						OpenUpdateTipsDialog(defaultTips, handled);
					}
				});
				AlertDialog dialog = builder.create();
				dialog.show();
			}

			break;
		}
	}

	private void SetCmdText(String text)
    {
		if(null == text || text.isEmpty())
			text = Q3EGlobals.GAME_EXECUABLE;
        EditText edit = V.edt_cmdline;
        if (edit.getText().toString().equals(text))
            return;
        int pos = edit.getSelectionStart();
        edit.setText(text);
		pos = Math.max(0, Math.min(pos, text.length()));
		try
		{
			edit.setSelection(pos);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
    }

	private String GetCmdText()
    {
		String s = V.edt_cmdline.getText().toString();
		if(s.isEmpty())
			s = Q3EGlobals.GAME_EXECUABLE;
		return s;
    }

    private void OpenGameLibChooser()
    {
        final String PreferenceKey = Q3EUtils.q3ei.GetGameModLibPreferenceKey();
        if (null == m_chooseGameLibFunc)
        {
            m_chooseGameLibFunc = new ChooseGameLibFunc(this, CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_GAME_LIBRARY);
            m_chooseGameLibFunc.SetAddCallback(new Runnable() {
                @Override
                public void run()
                {
                    if (null == m_addExternalLibraryFunc)
                        m_addExternalLibraryFunc = new AddExternalLibraryFunc(GameLauncher.this, new Runnable() {
                            @Override
                            public void run()
                            {
                                OpenGameLibChooser();
                            }
                        }, CONST_RESULT_CODE_REQUEST_ADD_EXTERNAL_GAME_LIBRARY);
                    Bundle bundle = new Bundle();
                    bundle.putString("path", GetExternalGameLibraryPath());
                    m_addExternalLibraryFunc.Start(bundle);
                }
            });
            m_chooseGameLibFunc.SetEditCallback(new Runnable() {
                @Override
                public void run()
                {
                    if (null == m_editExternalLibraryFunc)
                        m_editExternalLibraryFunc = new EditExternalLibraryFunc(GameLauncher.this, new Runnable() {
                            @Override
                            public void run()
                            {
                                OpenGameLibChooser();
                            }
                        }, CONST_RESULT_CODE_REQUEST_EDIT_EXTERNAL_GAME_LIBRARY);
                    Bundle bundle = new Bundle();
                    bundle.putString("path", GetExternalGameLibraryPath());
                    m_editExternalLibraryFunc.Start(bundle);
                }
            });
        }

        m_chooseGameLibFunc.SetCallback(new Runnable() {
            @Override
            public void run()
            {
                final SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(GameLauncher.this);
                String lib = m_chooseGameLibFunc.GetResult();
                if (null != lib && !lib.isEmpty())
                {
                    preference.edit().putString(PreferenceKey, lib).commit();
                    SetProp("harm_fs_gameLibPath", lib);
                }
                else
                {
                    preference.edit().putString(PreferenceKey, "").commit();
                    RemoveProp("harm_fs_gameLibPath");
                }
            }
        });
        Bundle bundle = new Bundle();
        bundle.putString("key", PreferenceKey);
        bundle.putString("path", GetExternalGameLibraryPath());
        m_chooseGameLibFunc.Start(bundle);
    }

	private void OpenCommandChooser()
	{
		final String PreferenceKey = Q3EUtils.q3ei.GetGameCommandRecordPreferenceKey();
		String cmd = GetCmdText();
		ChooseCommandRecordFunc m_chooseCommandRecordFunc = new ChooseCommandRecordFunc(this);
		m_chooseCommandRecordFunc.SetCallback(new Runnable() {
			@Override
			public void run()
			{
				String cmdResult = m_chooseCommandRecordFunc.GetResult();
				if(null != cmdResult && !cmd.equals(cmdResult))
				{
					// lock -> unregister listener -> set cmd text -> register listener -> unlock -> update GUI widgets
					LockCmdUpdate();
					SetupCommandTextWatcher(false);
					V.edt_cmdline.setText(cmdResult); // SetCmdText(cmdResult);
					SetupCommandTextWatcher(true);
					UnlockCmdUpdate();
					updatehacktings();
				}
			}
		});
		Bundle bundle = new Bundle();
		bundle.putString("command", cmd);
		bundle.putString("key", PreferenceKey);
		m_chooseCommandRecordFunc.Start(bundle);
	}

	private void OpenDirectoryHelper()
	{
		DirectoryHelperFunc m_directoryHelperFunc = new DirectoryHelperFunc(this);
		Bundle bundle = new Bundle();
		m_directoryHelperFunc.Start(bundle);
	}

	private void OpenShortcutCreator()
	{
/*		if(android.os.Build.VERSION.SDK_INT < android.os.Build.VERSION_CODES.N_MR1)
		{
			Toast.makeText(this, R.string.only_support_on_android_version_7_1, Toast.LENGTH_LONG).show();
			return;
		}*/
		if (null == m_createShortcutFunc)
		{
			m_createShortcutFunc = new CreateShortcutFunc(this, CONST_RESULT_CODE_REQUEST_CREATE_SHORTCUT);
		}
		Bundle bundle = new Bundle();
		m_createShortcutFunc.Start(bundle);
	}

	private void OpenShortcutWithCommandCreator()
	{
/*		if(android.os.Build.VERSION.SDK_INT < android.os.Build.VERSION_CODES.N_MR1)
		{
			Toast.makeText(this, R.string.only_support_on_android_version_7_1, Toast.LENGTH_LONG).show();
			return;
		}*/
		if (null == m_createCommandShortcutFunc)
		{
			m_createCommandShortcutFunc = new CreateCommandShortcutFunc(this, CONST_RESULT_CODE_REQUEST_CREATE_SHORTCUT_WITH_COMMAND);
		}
		Bundle bundle = new Bundle();
		bundle.putString("game", Q3EUtils.q3ei.GameType());
		String cmd = GetCmdText();
		String tmpCmd = GetTempCmdText();
		if(KStr.NotBlank(tmpCmd))
			cmd += " " + tmpCmd;
		bundle.putString("command", cmd);
		m_createCommandShortcutFunc.Start(bundle);
	}

    private void Test()
    {
		// test function
    }

    private void OpenSettings()
    {
        LauncherSettingsDialog dialog = LauncherSettingsDialog.newInstance();
        dialog.show(getFragmentManager(), "LauncherSettingsDialog");
    }

    private void OpenDebugDialog()
    {
        DebugDialog dialog = DebugDialog.newInstance();
        dialog.show(getFragmentManager(), "DebugDialog");
    }

	private void OpenExperimentalDialog()
	{
		ExperimentalDialog dialog = ExperimentalDialog.newInstance();
		dialog.show(getFragmentManager(), "ExperimentalDialog");
	}

	private void UpdateResolution(int rgid)
	{
		int type;

		if(rgid == R.id.rg_scrres_scheme_custom)
			type = 3;
		else if(rgid == R.id.rg_scrres_scheme_scale_area)
			type = 2;
		else if(rgid == R.id.rg_scrres_scheme_scale_length)
			type = 1;
		else
			type = 0;

		UpdateCustomerResolution(type == 3);
		UpdateResolutionScaleSchemeBar(type == 1 || type == 2);
		UpdateResolutionText();
	}

	private void UpdateResolutionText()
	{
		int[] size = Q3EUtils.GetFullScreenSize(this);
		size = Q3EUtils.GetSurfaceViewSize(this, size[0], size[1]);
		V.tv_scrres_size.setText(size[0] + " x " + size[1]);
	}

    private void UpdateCustomerResolution(boolean on)
    {
		V.res_x.setEnabled(on);
		V.res_y.setEnabled(on);
		V.res_customlayout.setEnabled(on);
		V.res_customlayout.setVisibility(on ? View.VISIBLE : View.GONE);
    }

    private void SetGameInternalMod(String val)
    {
        SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(this);
        boolean userMod = V.fs_game_user.isChecked(); //preference.getBoolean(Q3EUtils.q3ei.GetEnableModPreferenceKey(), false);
        String game = null != val ? val : "";
		GameManager.GameProp prop = m_gameManager.ChangeGameMod(game, userMod);
		HandleGameProp(prop);

        preference.edit().putString(Q3EUtils.q3ei.GetGameModPreferenceKey(), game).commit();
    }

    private boolean LockCmdUpdate()
    {
    	if(m_cmdUpdateLock)
    		return false;
        m_cmdUpdateLock = true;
        return true;
    }

    private void UnlockCmdUpdate()
    {
        m_cmdUpdateLock = false;
    }

    private boolean IsCmdUpdateLocked()
    {
        return m_cmdUpdateLock;
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, Intent data)
    {
        super.onActivityResult(requestCode, resultCode, data);
        if (resultCode == RESULT_OK)
        {
            switch (requestCode)
            {
                case CONST_RESULT_CODE_REQUEST_BACKUP_PREFERENCES_CHOOSE_FILE:
                    if (null != m_backupPreferenceFunc)
                    {
                        Bundle bundle = new Bundle();
                        bundle.putParcelable("uri", data.getData());
                        m_backupPreferenceFunc.Start(bundle);
                    }
                    break;
                case CONST_RESULT_CODE_REQUEST_RESTORE_PREFERENCES_CHOOSE_FILE:
                    if (null != m_restorePreferenceFunc)
                    {
                        Bundle bundle = new Bundle();
                        bundle.putParcelable("uri", data.getData());
                        m_restorePreferenceFunc.Start(bundle);
                    }
                    break;
                case CONST_RESULT_CODE_REQUEST_ADD_EXTERNAL_GAME_LIBRARY:
                    if (null != m_addExternalLibraryFunc)
                    {
                        Bundle bundle = new Bundle();
                        bundle.putParcelable("uri", data.getData());
                        m_addExternalLibraryFunc.Start(bundle);
                    }
					break;
				case CONST_RESULT_CODE_REQUEST_EXTRACT_SOURCE:
					if (null != m_extractSourceFunc)
					{
						Bundle bundle = new Bundle();
						bundle.putParcelable("uri", data.getData());
						m_extractSourceFunc.Start(bundle);
					}
					break;
				case CONST_RESULT_CODE_ACCESS_ANDROID_DATA:
					ContextUtility.PersistableUriPermission(this, data.getData());
					break;
            }
        }
		else
		{
			// Android SDK > 28: resultCode is RESULT_CANCELED
			if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.R) // Android 11 FS permission
			{
				if(requestCode == CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_START
						|| requestCode == CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_EDIT_CONFIG_FILE
						|| requestCode == CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_FOLDER
						|| requestCode == CONST_RESULT_CODE_REQUEST_EXTRACT_PATCH_RESOURCE
						|| requestCode == CONST_RESULT_CODE_REQUEST_BACKUP_PREFERENCES_CHOOSE_FILE
						|| requestCode == CONST_RESULT_CODE_REQUEST_RESTORE_PREFERENCES_CHOOSE_FILE
						|| requestCode == CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_GAME_LIBRARY
						|| requestCode == CONST_RESULT_CODE_REQUEST_ADD_EXTERNAL_GAME_LIBRARY
						|| requestCode == CONST_RESULT_CODE_REQUEST_EDIT_EXTERNAL_GAME_LIBRARY
						|| requestCode == CONST_RESULT_CODE_REQUEST_EXTRACT_SOURCE
						|| requestCode == CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_GAME_MOD
				)
				{
					List<String> list = null;
					if (!Environment.isExternalStorageManager()) // reject
					{
						list = Collections.singletonList(Settings.ACTION_MANAGE_ALL_FILES_ACCESS_PERMISSION);
					}
					HandleGrantPermissionResult(requestCode, list);
				}
			}
		}
    }

    private void HandleGrantPermissionResult(int requestCode, List<String> list)
    {
        if (null == list || list.isEmpty())
        {
            switch (requestCode)
            {
                case CONST_RESULT_CODE_REQUEST_EXTRACT_PATCH_RESOURCE:
                    if (null != m_extractPatchResourceFunc)
                        m_extractPatchResourceFunc.run();
                    break;
                case CONST_RESULT_CODE_REQUEST_BACKUP_PREFERENCES_CHOOSE_FILE:
                    if (null != m_backupPreferenceFunc)
                        m_backupPreferenceFunc.run();
                    break;
                case CONST_RESULT_CODE_REQUEST_RESTORE_PREFERENCES_CHOOSE_FILE:
                    if (null != m_restorePreferenceFunc)
                        m_restorePreferenceFunc.run();
                    break;
                case CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_EDIT_CONFIG_FILE:
                    if (null != m_editConfigFileFunc)
                        m_editConfigFileFunc.run();
                    break;
                case CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_FOLDER:
                    if (null != m_chooseGameFolderFunc)
                        m_chooseGameFolderFunc.run();
                    break;
                case CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_START:
                    if (null != m_startGameFunc)
                        m_startGameFunc.run();
                    break;
                case CONST_RESULT_CODE_REQUEST_ADD_EXTERNAL_GAME_LIBRARY:
                    if (null != m_addExternalLibraryFunc)
                        m_addExternalLibraryFunc.run();
                    break;
                case CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_GAME_LIBRARY:
                    if (null != m_chooseGameLibFunc)
                        m_chooseGameLibFunc.run();
                    break;
                case CONST_RESULT_CODE_REQUEST_EDIT_EXTERNAL_GAME_LIBRARY:
                    if (null != m_editExternalLibraryFunc)
                        m_editExternalLibraryFunc.run();
                    break;
				case CONST_RESULT_CODE_REQUEST_EXTRACT_SOURCE:
					if (null != m_extractSourceFunc)
						m_extractSourceFunc.run();
					break;
				case CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_GAME_MOD:
					if (null != m_chooseGameModFunc)
						m_chooseGameModFunc.run();
					break;
				case CONST_RESULT_CODE_REQUEST_CREATE_SHORTCUT:
					if (null != m_createShortcutFunc)
						m_createShortcutFunc.run();
					break;
				case CONST_RESULT_CODE_REQUEST_CREATE_SHORTCUT_WITH_COMMAND:
					if (null != m_createCommandShortcutFunc)
						m_createCommandShortcutFunc.run();
					break;
				case CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_EXTRAS_FILE:
					if (null != m_chooseExtrasFileFunc)
						m_chooseExtrasFileFunc.run();
					break;
                default:
                    break;
            }
            return;
        }
        // not grant
        String opt;
        switch (requestCode)
        {
            case CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_START:
                opt = Q3ELang.tr(this, R.string.start_game);
                break;
            case CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_EDIT_CONFIG_FILE:
                opt = Q3ELang.tr(this, R.string.edit_config_file);
                break;
            case CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_FOLDER:
                opt = Q3ELang.tr(this, R.string.choose_data_folder);
                break;
            case CONST_RESULT_CODE_REQUEST_EXTRACT_PATCH_RESOURCE:
                opt = Q3ELang.tr(this, R.string.extract_resource);
                break;
            case CONST_RESULT_CODE_REQUEST_BACKUP_PREFERENCES_CHOOSE_FILE:
                opt = Q3ELang.tr(this, R.string.backup_settings);
                break;
            case CONST_RESULT_CODE_REQUEST_RESTORE_PREFERENCES_CHOOSE_FILE:
                opt = Q3ELang.tr(this, R.string.restore_settings);
                break;
            case CONST_RESULT_CODE_REQUEST_ADD_EXTERNAL_GAME_LIBRARY:
                opt = Q3ELang.tr(this, R.string.add_external_game_library);
                break;
            case CONST_RESULT_CODE_REQUEST_EDIT_EXTERNAL_GAME_LIBRARY:
                opt = Q3ELang.tr(this, R.string.edit_external_game_library);
                break;
            case CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_GAME_LIBRARY:
                opt = Q3ELang.tr(this, R.string.access_external_game_library);
                break;
			case CONST_RESULT_CODE_REQUEST_CREATE_SHORTCUT:
				opt = Q3ELang.tr(this, R.string.create_desktop_shortcut);
				break;
            default:
                opt = Q3ELang.tr(this, R.string.operation);
                break;
        }
        StringBuilder sb = new StringBuilder();
        String endl = TextHelper.GetDialogMessageEndl();
        for (String str : list)
        {
            if (str != null)
                sb.append("  * ").append(str);
            sb.append(endl);
        }
        AlertDialog.Builder builder = ContextUtility.CreateMessageDialogBuilder(this, opt + " " + Q3ELang.tr(this, R.string.request_necessary_permissions), TextHelper.GetDialogMessage(sb.toString()));
        builder.setNeutralButton(R.string.grant, new AlertDialog.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which)
            {
                ContextUtility.OpenAppSetting(GameLauncher.this);
                dialog.dismiss();
            }
        });
        builder.create().show();
    }

    private void OpenOnScreenButtonSetting()
    {
        Intent intent = new Intent(this, OnScreenButtonConfigActivity.class);
        startActivity(intent);
    }

    private void OpenCvarListDetail()
    {
        ContextUtility.OpenMessageDialog(this, Q3ELang.tr(this, R.string.special_cvar_list), TextHelper.GetCvarText());
    }

    private void SetGame(String game)
    {
        Q3EUtils.q3ei.SetupGame(game);
        V.launcher_tab1_edit_doomconfig.setText(getString(R.string.edit_) + Q3EUtils.q3ei.config_name);
        if (null != V.main_menu_game)
            V.main_menu_game.setTitle(Q3EUtils.q3ei.game_name);
        ActionBar actionBar = getActionBar();
        Resources res = getResources();
        int colorId = GameManager.GetGameThemeColor();
        int iconId = GameManager.GetGameIcon();

        boolean d3Visible = false;
        boolean q4Visible = false;
        boolean preyVisible = false;
		boolean q1Visible = false;
		boolean q2Visible = false;
		boolean q3Visible = false;
		boolean rtcwVisible = false;
		boolean tdmVisible = false;
		boolean d3bfgVisible = false;
		boolean doomVisible = false;
		boolean etwVisible = false;
		boolean realrtcwVisible = false;
		boolean fetqwVisible = false;

		boolean openglVisible = true;
		boolean quickloadVisible = true;
		boolean skipintroVisible = true;

        if (Q3EUtils.q3ei.isPrey)
        {
            preyVisible = true;
        }
        else if (Q3EUtils.q3ei.isQ4)
        {
            q4Visible = true;
        }
		else if (Q3EUtils.q3ei.isQ1)
		{
			q1Visible = true;
			openglVisible = false;
			quickloadVisible = false;
			skipintroVisible = false;
		}
		else if (Q3EUtils.q3ei.isQ2)
		{
			q2Visible = true;
			openglVisible = false;
			quickloadVisible = false;
			skipintroVisible = false;
		}
		else if (Q3EUtils.q3ei.isQ3)
		{
			q3Visible = true;
			openglVisible = false;
			quickloadVisible = false;
		}
		else if (Q3EUtils.q3ei.isRTCW)
		{
			rtcwVisible = true;
			openglVisible = false;
		}
		else if (Q3EUtils.q3ei.isTDM)
		{
			tdmVisible = true;
			openglVisible = false;
			quickloadVisible = false;
			skipintroVisible = false;
		}
		else if (Q3EUtils.q3ei.isD3BFG)
		{
			d3bfgVisible = true;
			openglVisible = false;
			quickloadVisible = false;
			skipintroVisible = false;
		}
		else if (Q3EUtils.q3ei.isDOOM)
		{
			doomVisible = true;
			openglVisible = false;
			quickloadVisible = false;
			skipintroVisible = false;
		}
		else if (Q3EUtils.q3ei.isETW)
		{
			etwVisible = true;
			openglVisible = false;
			quickloadVisible = false;
		}
		else if (Q3EUtils.q3ei.isRealRTCW)
		{
			realrtcwVisible = true;
			openglVisible = false;
		}
		else if (Q3EUtils.q3ei.isFTEQW)
		{
			fetqwVisible = true;
			openglVisible = false;
			quickloadVisible = false;
			skipintroVisible = false;
		}
        else
        {
            d3Visible = true;
        }
        if (null != actionBar)
        {
            actionBar.setBackgroundDrawable(new ColorDrawable(res.getColor(colorId)));
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.JELLY_BEAN_MR2)
            {
                actionBar.setHomeAsUpIndicator(iconId);
            }
        }
        V.rg_fs_game.setVisibility(d3Visible ? View.VISIBLE : View.GONE);
        V.rg_fs_q4game.setVisibility(q4Visible ? View.VISIBLE : View.GONE);
        V.rg_fs_preygame.setVisibility(preyVisible ? View.VISIBLE : View.GONE);
		V.rg_fs_q1game.setVisibility(q1Visible ? View.VISIBLE : View.GONE);
		V.rg_fs_q2game.setVisibility(q2Visible ? View.VISIBLE : View.GONE);
		V.rg_fs_q3game.setVisibility(q3Visible ? View.VISIBLE : View.GONE);
		V.rg_fs_rtcwgame.setVisibility(rtcwVisible ? View.VISIBLE : View.GONE);
		V.rg_fs_tdmgame.setVisibility(tdmVisible ? View.VISIBLE : View.GONE);
		V.rg_fs_d3bfggame.setVisibility(d3bfgVisible ? View.VISIBLE : View.GONE);
		V.rg_fs_doomgame.setVisibility(doomVisible ? View.VISIBLE : View.GONE);
		V.rg_fs_etwgame.setVisibility(etwVisible ? View.VISIBLE : View.GONE);
		V.rg_fs_realrtcwgame.setVisibility(realrtcwVisible ? View.VISIBLE : View.GONE);
		V.rg_fs_fteqwgame.setVisibility(fetqwVisible ? View.VISIBLE : View.GONE);

		V.idtech4_section.setVisibility(Q3EUtils.q3ei.IsIdTech4() ? View.VISIBLE : View.GONE);
		V.yquake2_section.setVisibility(Q3EUtils.q3ei.isQ2 ? View.VISIBLE : View.GONE);
		V.doom3bfg_section.setVisibility(Q3EUtils.q3ei.isD3BFG ? View.VISIBLE : View.GONE);
		V.realrtcw_section.setVisibility(Q3EUtils.q3ei.isRealRTCW ? View.VISIBLE : View.GONE);
		V.etw_section.setVisibility(Q3EUtils.q3ei.isETW ? View.VISIBLE : View.GONE);
		V.gzdoom_section.setVisibility(Q3EUtils.q3ei.isDOOM ? View.VISIBLE : View.GONE);
		V.tdm_section.setVisibility(Q3EUtils.q3ei.isTDM ? View.VISIBLE : View.GONE);
		V.fteqw_section.setVisibility(Q3EUtils.q3ei.isFTEQW ? View.VISIBLE : View.GONE);

		V.opengl_section.setVisibility(openglVisible ? View.VISIBLE : View.GONE);
		V.auto_quick_load.setVisibility(quickloadVisible ? View.VISIBLE : View.GONE);
		V.skip_intro.setVisibility(skipintroVisible ? View.VISIBLE : View.GONE);

		String subdir = Q3EUtils.q3ei.subdatadir;
		if(null == subdir)
			subdir = "";
		else
			subdir += "/";
		String gameCommandParm = Q3EUtils.q3ei.GetGameCommandParm();
		V.launcher_fs_game_cvar.setText(KStr.NotEmpty(gameCommandParm) ? "(" + gameCommandParm + ")" : "");
		V.launcher_fs_game_subdir.setText(Q3ELang.tr(this, R.string.sub_directory) + subdir);
		V.launcher_fs_game_subdir.setVisibility(subdir.isEmpty() ? View.GONE : View.VISIBLE);

		CollapseMods(V.collapse_mods.isChecked());
    }

    private void ChangeGame(String... games)
    {
		LockCmdUpdate();
		SetupCommandTextWatcher(false);
        String newGame = games.length > 0 ? games[0] : null;
        if (null == newGame || newGame.isEmpty())
        {
            int i;
            for (i = 0; i < GameManager.Games.length; i++)
            {
                if (GameManager.Games[i].equalsIgnoreCase(Q3EUtils.q3ei.game))
                    break;
            }
            if (i >= GameManager.Games.length)
                i = GameManager.Games.length - 1;
            newGame = GameManager.Games[(i + 1) % GameManager.Games.length];
        }
        SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(this);
        preference.edit().putString(Q3EPreference.pref_harm_game, newGame).commit();
        SetGame(newGame);
        preference.edit().putString(Q3EPreference.pref_harm_game_lib, "").commit();

		String cmd = preference.getString(Q3EUtils.q3ei.GetGameCommandPreferenceKey(), Q3EGlobals.GAME_EXECUABLE);
		V.edt_cmdline.setText(cmd);
		SetupCommandTextWatcher(true);
		UnlockCmdUpdate();

		// if is DOOM3/Quake4/Prey, update launcher
		updatehacktings();

		// put last
		String game = preference.getString(Q3EUtils.q3ei.GetGameModPreferenceKey(), "");
		if (null == game)
			game = "";
		boolean userMod = preference.getBoolean(Q3EUtils.q3ei.GetEnableModPreferenceKey(), false);
		V.fs_game_user.setChecked(userMod);
		String userModName = preference.getString(Q3EUtils.q3ei.GetGameUserModPreferenceKey(), "");
		String cur = V.edt_fs_game.getText().toString();
		if (!userModName.equals(cur))
		{
			V.edt_fs_game.setText(userModName);
		}
		if(userMod)
			game = userModName;

		GameManager.GameProp prop = m_gameManager.ChangeGameMod(game, userMod);
		HandleGameProp(prop);
		SelectRadioGroup(GetGameModRadioGroup(), prop.index);

		Q3EUtils.q3ei.start_temporary_extra_command = Q3EUtils.q3ei.MakeTempBaseCommand(this);
		UpdateTempCommand();
    }

	private void SetupCommandTextWatcher(boolean b)
	{
		if(b)
		{
			V.edt_cmdline.addTextChangedListener(m_commandTextWatcher);
			m_commandTextWatcher.Install(true);
		}
		else
		{
			m_commandTextWatcher.Uninstall();
			V.edt_cmdline.removeTextChangedListener(m_commandTextWatcher);
		}
	}

    private void OpenResourceFileDialog(boolean all)
    {
        if (null == m_extractPatchResourceFunc)
            m_extractPatchResourceFunc = new ExtractPatchResourceFunc(this, CONST_RESULT_CODE_REQUEST_EXTRACT_PATCH_RESOURCE);
        Bundle bundle = new Bundle();
        bundle.putString("path", V.edt_path.getText().toString());
		bundle.putString("game", Q3EUtils.q3ei.game);
		bundle.putBoolean("all", all);
		SharedPreferences preferences = PreferenceManager.getDefaultSharedPreferences(this);
		boolean userMod = preferences.getBoolean(Q3EInterface.GetEnableModPreferenceKey(Q3EUtils.q3ei.game), false);
		String gamebase = Q3EInterface.GetGameBaseDirectory(Q3EUtils.q3ei.game);
		String base;
		if(userMod)
		{
			base = preferences.getString(Q3EInterface.GetGameModPreferenceKey(Q3EUtils.q3ei.game), gamebase);
		}
		else
			base = GetGameModFromCommand();
		if(KStr.IsEmpty(base))
			base = gamebase;
		bundle.putString("mod", base);
        m_extractPatchResourceFunc.Start(bundle);
    }

    private void RemoveParam(String name)
    {
        if(!LockCmdUpdate())
        	return;
        String orig = GetCmdText();
		String str = Q3EUtils.q3ei.GetGameCommandEngine(orig).RemoveParam(name).toString();
        if (!orig.equals(str))
            SetCmdText(str);
        UnlockCmdUpdate();
    }

    private void SetParam(String name, Object val)
    {
		if(!LockCmdUpdate())
			return;
        SetCmdText(Q3EUtils.q3ei.GetGameCommandEngine(GetCmdText()).SetParam(name, val).toString());
		// SetCmdText(KidTech4Command.SetParam(GetCmdText(), name, val));
        UnlockCmdUpdate();
    }

    private String GetParam(String name)
    {
		return Q3EUtils.q3ei.GetGameCommandEngine(GetCmdText()).Param(name);
        // return KidTech4Command.GetParam(GetCmdText(), name);
    }

	private List<String> GetParamList(String name)
	{
		String parm = GetParam(name);
		if(null == parm)
			return null;
		else if(parm.trim().isEmpty())
			return new ArrayList<>();
		else
			return KidTechCommand.SplitValue(parm, true);
	}

	private void SetParamList(String name, List<String> parms)
	{
		SetParam(name, KidTechCommand.JoinValue(parms, true));
	}

    private void SetParamPrefix(String prefix, String name, Object val)
    {
		if(!LockCmdUpdate())
			return;
		SetCmdText(new KidTechCommand(prefix, GetCmdText()).SetParam(name, val).toString());
        UnlockCmdUpdate();
    }

	private void RemoveAllParamsPrefix(String prefix)
	{
		if(!LockCmdUpdate())
			return;
		SetCmdText(new KidTechCommand(prefix, GetCmdText()).RemoveAllParams().toString());
		UnlockCmdUpdate();
	}

	private String GetParamPrefix(String prefix, String name)
	{
		return new KidTechCommand(prefix, GetCmdText()).Param(name);
		// return KidTech4Command.GetParam(GetCmdText(), name);
	}

	private void RemoveParamPrefix(String prefix, String name)
	{
		if(!LockCmdUpdate())
			return;
		String orig = GetCmdText();
		String str = new KidTechCommand(prefix, orig).RemoveParam(name).toString();
		if (!orig.equals(str))
			SetCmdText(str);
		UnlockCmdUpdate();
	}

	private String GetTempCmdText()
	{
		return V.edt_cmdline_temp.getText().toString();
	}

    private void RemoveParam_temp(String name, String...val)
    {
		String orig = GetTempCmdText();
        String str = Q3EUtils.q3ei.GetGameCommandEngine(orig).RemoveParam(name, val).toString();
        if (!orig.equals(str))
            Q3EUtils.q3ei.start_temporary_extra_command = str;
		UpdateTempCommand();
    }

	private void AddParam_temp(String name, Object val)
	{
		Q3EUtils.q3ei.start_temporary_extra_command = Q3EUtils.q3ei.GetGameCommandEngine(GetTempCmdText()).AddParam(name, val).toString();
		UpdateTempCommand();
	}

    private void SetParam_temp(String name, Object val)
    {
		Q3EUtils.q3ei.start_temporary_extra_command = Q3EUtils.q3ei.GetGameCommandEngine(GetTempCmdText()).SetParam(name, val).toString();
		UpdateTempCommand();
    }

	private void SetProp_temp(String name, Object val)
	{
		Q3EUtils.q3ei.start_temporary_extra_command = Q3EUtils.q3ei.GetGameCommandEngine(GetTempCmdText()).SetProp(name, val).toString();
		UpdateTempCommand();
	}

	private void RemoveProp_temp(String name)
	{
		String orig = GetTempCmdText();
		String str = Q3EUtils.q3ei.GetGameCommandEngine(orig).RemoveProp(name).toString();
		if (!orig.equals(str))
			Q3EUtils.q3ei.start_temporary_extra_command = str;
		UpdateTempCommand();
	}

	private void SetCommand_temp(String name, boolean prepend)
	{
		Q3EUtils.q3ei.start_temporary_extra_command = Q3EUtils.q3ei.GetGameCommandEngine(GetTempCmdText()).SetCommand(name, prepend).toString();
		UpdateTempCommand();
	}

	private void RemoveCommand_temp(String name)
	{
		String orig = GetTempCmdText();
		String str = Q3EUtils.q3ei.GetGameCommandEngine(orig).RemoveCommand(name).toString();
		if (!orig.equals(str))
			Q3EUtils.q3ei.start_temporary_extra_command = str;
		UpdateTempCommand();
	}

    private void ShowPreferenceDialog()
    {
        new DebugPreferenceFunc(this).Start(new Bundle());
    }

    private void UpdateMapVol(boolean on)
    {
        SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(this);
        int[] keyCodes = getResources().getIntArray(R.array.key_map_codes);
        // V.launcher_tab2_volume_map_config_layout.setVisibility(on ? View.VISIBLE : View.GONE); // always visible
        int key = preference.getInt(Q3EPreference.VOLUME_UP_KEY, Q3EKeyCodes.KeyCodes.K_F3);
        V.launcher_tab2_volume_up_map_config_keys.setSelection(Utility.ArrayIndexOf(keyCodes, key));
        key = preference.getInt(Q3EPreference.VOLUME_DOWN_KEY, Q3EKeyCodes.KeyCodes.K_F2);
        V.launcher_tab2_volume_down_map_config_keys.setSelection(Utility.ArrayIndexOf(keyCodes, key));
		// only disable
		V.launcher_tab2_volume_up_map_config_keys.setEnabled(on);
		V.launcher_tab2_volume_down_map_config_keys.setEnabled(on);
    }

    private void UpdateEnableGyro(boolean on)
    {
        // V.launcher_tab2_enable_gyro_layout.setVisibility(on ? View.VISIBLE : View.GONE); // always visible
        SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(this);
        V.launcher_tab2_gyro_x_axis_sens.setText(Q3EPreference.GetStringFromFloat(preference, Q3EPreference.pref_harm_view_motion_gyro_x_axis_sens, Q3EControlView.GYROSCOPE_X_AXIS_SENS));
        V.launcher_tab2_gyro_y_axis_sens.setText(Q3EPreference.GetStringFromFloat(preference, Q3EPreference.pref_harm_view_motion_gyro_y_axis_sens, Q3EControlView.GYROSCOPE_Y_AXIS_SENS));
		// only disable
		V.launcher_tab2_gyro_x_axis_sens.setEnabled(on);
		V.launcher_tab2_gyro_y_axis_sens.setEnabled(on);
    }

    private void OpenCheckForUpdateDialog()
    {
        if (null == m_checkForUpdateFunc)
            m_checkForUpdateFunc = new CheckForUpdateFunc(this);
        m_checkForUpdateFunc.Start(new Bundle());
    }

    private RadioGroup GetGameModRadioGroup()
    {
		if(Q3EUtils.q3ei.isQ4)
			return V.rg_fs_q4game;
		else if(Q3EUtils.q3ei.isPrey)
			return V.rg_fs_preygame;
		else if(Q3EUtils.q3ei.isQ1)
			return V.rg_fs_q1game;
		else if(Q3EUtils.q3ei.isQ2)
			return V.rg_fs_q2game;
		else if(Q3EUtils.q3ei.isQ3)
			return V.rg_fs_q3game;
		else if(Q3EUtils.q3ei.isRTCW)
			return V.rg_fs_rtcwgame;
		else if(Q3EUtils.q3ei.isTDM)
			return V.rg_fs_tdmgame;
		else if(Q3EUtils.q3ei.isD3BFG)
			return V.rg_fs_d3bfggame;
		else if(Q3EUtils.q3ei.isDOOM)
			return V.rg_fs_doomgame;
		else if(Q3EUtils.q3ei.isETW)
			return V.rg_fs_etwgame;
		else if(Q3EUtils.q3ei.isRealRTCW)
			return V.rg_fs_realrtcwgame;
		else if(Q3EUtils.q3ei.isFTEQW)
			return V.rg_fs_fteqwgame;
		else
        	return V.rg_fs_game;
    }

    private void RequestBackupPreferences()
    {
        if (null == m_backupPreferenceFunc)
            m_backupPreferenceFunc = new BackupPreferenceFunc(this, CONST_RESULT_CODE_REQUEST_BACKUP_PREFERENCES_CHOOSE_FILE);
        m_backupPreferenceFunc.Start(new Bundle());
    }

    private void RequestRestorePreferences()
    {
        if (null == m_restorePreferenceFunc)
            m_restorePreferenceFunc = new RestorePreferenceFunc(this, CONST_RESULT_CODE_REQUEST_RESTORE_PREFERENCES_CHOOSE_FILE);
        m_restorePreferenceFunc.Start(new Bundle());
    }

    private void OpenOnScreenButtonThemeSetting()
    {
        new SetupControlsThemeFunc(this).Start(new Bundle());
    }

    private String GetExternalGameLibraryPath()
    {
        return getFilesDir() + File.separator + Q3EUtils.q3ei.game + File.separator + Q3EGlobals.ARCH;
    }

    private void OpenTranslatorsDialog()
	{
		new TranslatorsFunc(this).Start(new Bundle());
	}

	private void EditCVar()
	{
		Bundle bundle = new Bundle();
		bundle.putString("game", GetGameModFromCommand());
		bundle.putString("command", Q3EUtils.q3ei.start_temporary_extra_command);
		bundle.putString("baseCommand", Q3EUtils.q3ei.MakeTempBaseCommand(this));
		// bundle.putString("persistentCommand", GetCmdText());
		CVarEditorFunc cVarEditorFunc = new CVarEditorFunc(this, new Runnable() {
			@Override
			public void run()
			{
				Q3EUtils.q3ei.start_temporary_extra_command = CVarEditorFunc.GetResultFromBundle(bundle);
				UpdateTempCommand();
			}
		});
		cVarEditorFunc.Start(bundle);
	}

	private void UpdateTempCommand()
	{
		Q3EUtils.q3ei.start_temporary_extra_command = Q3EUtils.q3ei.start_temporary_extra_command.trim(); //k: trim it 20241114

		if(Q3EUtils.q3ei.start_temporary_extra_command.equals(GetTempCmdText()))
			return;

		V.edt_cmdline_temp.setText(Q3EUtils.q3ei.start_temporary_extra_command);
		V.temp_cmdline.setVisibility(Q3EUtils.q3ei.start_temporary_extra_command.length() > 0 ? View.VISIBLE : View.GONE);
	}

	private void OpenGameModChooser()
	{
		SharedPreferences preference = PreferenceManager.getDefaultSharedPreferences(this);
		String preferenceKey = Q3EUtils.q3ei.GetGameModPreferenceKey();
		if (null == m_chooseGameModFunc)
		{
			m_chooseGameModFunc = new ChooseGameModFunc(this, CONST_RESULT_CODE_REQUEST_EXTERNAL_STORAGE_FOR_CHOOSE_GAME_MOD);
		}

		m_chooseGameModFunc.SetCallback(new Runnable() {
			@Override
			public void run()
			{
				String mod = m_chooseGameModFunc.GetResult();
				if(mod.startsWith(":"))
					SetupExtrasFiles(mod);
				else
				{
					String cur = V.edt_fs_game.getText().toString();
					if (!mod.equals(cur))
						V.edt_fs_game.setText(mod);
				}
			}
		});
		Bundle bundle = new Bundle();
		String path = KStr.AppendPath(preference.getString(Q3EPreference.pref_datapath, default_gamedata), Q3EUtils.q3ei.subdatadir, Q3EUtils.q3ei.GetGameModSubDirectory());
		bundle.putString("mod", preference.getString(preferenceKey, ""));
		bundle.putString("path", path);
		if(Q3EUtils.q3ei.isDOOM)
			bundle.putString("file", GetParamPrefix(KidTechCommand.ARG_PREFIX_ALL, "file") + " " + GetParamPrefix(KidTechCommand.ARG_PREFIX_ALL, "deh") + " " + GetParamPrefix(KidTechCommand.ARG_PREFIX_ALL, "bex"));
		m_chooseGameModFunc.Start(bundle);
	}

/*
	private void UpdateResolutionScaleScheme(int checkedId)
	{
		boolean usingPercent = checkedId == R.id.res_05x
				|| checkedId == R.id.res_2x
				|| checkedId == R.id.res_1p3x
				|| checkedId == R.id.res_1p4x
				;
		V.scale_by_screen_area.setEnabled(usingPercent);
	}
*/

	private void UpdateResolutionScaleSchemeBar(boolean on)
	{
		V.res_scale.setEnabled(on);
		V.res_scale_layout.setEnabled(on);
		V.res_scale_layout.setVisibility(on ? View.VISIBLE : View.GONE);
	}

	private void HandleGameProp(GameManager.GameProp prop)
	{
		boolean b = m_commandTextWatcher.IsEnabled();
		m_commandTextWatcher.Uninstall();
		if(prop.is_user)
		{
			if (!prop.fs_game.isEmpty())
				SetGameModToCommand(prop.fs_game);
			else
				RemoveGameModFromCommand();
			RemoveSecondaryGameModFromCommand();
			RemoveProp("harm_fs_gameLibPath");
		}
		else
		{
			if(null == prop.fs_game || prop.fs_game.isEmpty() || !prop.IsValid())
				RemoveGameModFromCommand();
			else
				SetGameModToCommand(prop.fs_game);
			if(null == prop.fs_game_base || prop.fs_game_base.isEmpty() || !prop.IsValid())
				RemoveSecondaryGameModFromCommand();
			else if(Q3EUtils.q3ei.IsIdTech4() || Q3EUtils.q3ei.isD3BFG || Q3EUtils.q3ei.isTDM || Q3EUtils.q3ei.isFTEQW)
				SetSecondaryGameModToCommand(prop.fs_game_base);
			RemoveProp("harm_fs_gameLibPath");
		}
		m_commandTextWatcher.Install(b);
	}

	public GameManager GetGameManager()
	{
		return m_gameManager;
	}

	private void InitGameList()
	{
		groupRadios.clear();
		RadioButton radio;
		RadioGroup group;
		RadioGroup.LayoutParams layoutParams;

		groupRadios.put(Q3EGlobals.GAME_DOOM3, V.rg_fs_game);
		groupRadios.put(Q3EGlobals.GAME_QUAKE4, V.rg_fs_q4game);
		groupRadios.put(Q3EGlobals.GAME_PREY, V.rg_fs_preygame);
		groupRadios.put(Q3EGlobals.GAME_QUAKE1, V.rg_fs_q1game);
		groupRadios.put(Q3EGlobals.GAME_QUAKE2, V.rg_fs_q2game);
		groupRadios.put(Q3EGlobals.GAME_QUAKE3, V.rg_fs_q3game);
		groupRadios.put(Q3EGlobals.GAME_RTCW, V.rg_fs_rtcwgame);
		groupRadios.put(Q3EGlobals.GAME_TDM, V.rg_fs_tdmgame);
		groupRadios.put(Q3EGlobals.GAME_DOOM3BFG, V.rg_fs_d3bfggame);
		groupRadios.put(Q3EGlobals.GAME_GZDOOM, V.rg_fs_doomgame);
		groupRadios.put(Q3EGlobals.GAME_ETW, V.rg_fs_etwgame);
		groupRadios.put(Q3EGlobals.GAME_REALRTCW, V.rg_fs_realrtcwgame);
		groupRadios.put(Q3EGlobals.GAME_FTEQW, V.rg_fs_fteqwgame);
		Game[] values = Game.values();

		for (Game value : values)
		{
/*			String subdir = "";

			if(Q3EUtils.q3ei.standalone)
			{
				subdir = Q3EInterface.GetGameStandaloneDirectory(value.type);
				if(!subdir.isEmpty())
					subdir += "/";
			}*/

			group = groupRadios.get(value.type);
			layoutParams = new RadioGroup.LayoutParams(RadioGroup.LayoutParams.WRAP_CONTENT, RadioGroup.LayoutParams.WRAP_CONTENT);
			radio = new RadioButton(group.getContext());
			String name;
			if(value.name instanceof Integer)
				name = Q3ELang.tr(this, (Integer)value.name);
			else if(value.name instanceof String)
				name = (String)value.name;
			else
				name = "";
			if(Q3EGlobals.GAME_GZDOOM.equalsIgnoreCase(value.type))
			{
				name += " (" + /*subdir +*/ value.file + ")";
			}
			else
			{
				if(KStr.NotEmpty(value.fs_game))
					name += " [" + value.fs_game + "]";
				if(KStr.NotEmpty(value.file))
					name += " (" + /*subdir +*/ value.file + "/)";
			}
			radio.setText(name);
			radio.setTag(value.game);
			group.addView(radio, layoutParams);
			radio.setChecked(!value.is_mod);
		}
	}

	private void SetupCommandLine(boolean readonly)
	{
		UIUtility.EditText__SetReadOnly(V.edt_cmdline, readonly, InputType.TYPE_TEXT_FLAG_NO_SUGGESTIONS);
	}

	private void SetupTempCommandLine(boolean editable)
	{
		UIUtility.EditText__SetReadOnly(V.edt_cmdline_temp, !editable, InputType.TYPE_TEXT_FLAG_NO_SUGGESTIONS);
	}

	public void OpenSuggestGameWorkingDirectory(String curPath)
	{
		if(ContextUtility.InScopedStorage() && !ContextUtility.IsInAppPrivateDirectory(GameLauncher.this, curPath))
		{
			String path = Q3EUtils.GetAppStoragePath(GameLauncher.this);
			Toast.makeText(GameLauncher.this, Q3ELang.tr(this, R.string.suggest_game_woring_directory_tips, path), Toast.LENGTH_LONG).show();
		}
		m_edtPathFocused = curPath;
	}

	private void SetGameModToCommand(String mod)
	{
		String arg = Q3EUtils.q3ei.GetGameCommandParm();
		if(Q3EUtils.q3ei.isQ1)
			SetParam(arg, mod);
		else if(Q3EUtils.q3ei.isDOOM)
		{
			RemoveParamPrefix(KidTechCommand.ARG_PREFIX_ALL, arg);
			SetParam(arg, mod);
		}
		else if(Q3EUtils.q3ei.isFTEQW)
		{
			RemoveAllParamsPrefix(KidTechCommand.ARG_PREFIX_QUAKETECH);
			SetParamPrefix(KidTechCommand.ARG_PREFIX_QUAKETECH, mod, "");
		}
		else
			SetProp(arg, mod);
	}

	private String GetGameModFromCommand()
	{
		String arg = Q3EUtils.q3ei.GetGameCommandParm();
		if(Q3EUtils.q3ei.isQ1)
			return GetParam(arg);
		else if(Q3EUtils.q3ei.isDOOM)
			return GetParamPrefix(KidTechCommand.ARG_PREFIX_ALL, arg);
		else if(Q3EUtils.q3ei.isFTEQW)
		{
			List<String> list = new KidTechCommand(KidTechCommand.ARG_PREFIX_ALL, GetCmdText()).GetAllParamNames();
			if(!list.isEmpty())
			{
				String parm = list.get(0);
				return KStr.TrimLeft(parm, '-');
			}
			else
				return "";
		}
		else
			return GetProp(arg);
	}

	private void RemoveGameModFromCommand()
	{
		String arg = Q3EUtils.q3ei.GetGameCommandParm();
		if(Q3EUtils.q3ei.isQ1)
			RemoveParam(arg);
		else if(Q3EUtils.q3ei.isDOOM)
			RemoveParamPrefix(KidTechCommand.ARG_PREFIX_ALL, arg);
		else if(Q3EUtils.q3ei.isFTEQW)
			RemoveAllParamsPrefix(KidTechCommand.ARG_PREFIX_QUAKETECH);
		else
			RemoveProp(arg);
	}

	private void SetSecondaryGameModToCommand(String mod)
	{
		String arg = Q3EUtils.q3ei.GetSecondaryGameCommandParm();
		if(Q3EUtils.q3ei.isFTEQW)
		{
			SetParamPrefix(KidTechCommand.ARG_PREFIX_QUAKETECH, arg, mod);
		}
		else
			SetProp(arg, mod);
	}

	private void RemoveSecondaryGameModFromCommand()
	{
		String arg = Q3EUtils.q3ei.GetSecondaryGameCommandParm();
		if(Q3EUtils.q3ei.isFTEQW)
			RemoveParamPrefix(KidTechCommand.ARG_PREFIX_QUAKETECH, arg);
		else
			RemoveProp(arg);
	}

	private void SetupGZDOOMFiles(String name, String file, boolean checked)
	{
		PreferenceManager.getDefaultSharedPreferences(GameLauncher.this).edit()
				.putBoolean(Q3EPreference.pref_harm_gzdoom_load_lights_pk3, checked)
				.commit();
		if (checked)
			AddParam_temp(name, file);
		else
			RemoveParam_temp(name, file);
/*
// from parsing command
		boolean changed = false;
		List<String> files = GetParamList(name);
		if(checked)
		{
			if(null == files)
			{
				files = new ArrayList<>();
				files.add(file);
				changed = true;
			}
			else if(!files.contains(file))
			{
				files.add(0, file);
				changed = true;
			}
		}
		else
		{
			if(null != files && files.contains(file))
			{
				files.remove(file);
				changed = true;
			}
		}
		if(changed)
			SetParamList(name, files);*/
	}

	private void CollapseMods(boolean on)
	{
		final int VisibleRadioCount = 4;
		RadioGroup radioGroup = null;
		int childCount = V.mods_container_layout.getChildCount();
		for(int i = 0; i < childCount; i++)
		{
			View view = V.mods_container_layout.getChildAt(i);
			if(view.getVisibility() == View.VISIBLE)
			{
				int radioCount = ((RadioGroup)view).getChildCount();
				if(radioCount > VisibleRadioCount)
				{
					radioGroup = (RadioGroup)view;
				}
				break;
			}
		}

		ViewGroup.LayoutParams layoutParams = V.mods_container.getLayoutParams();
		if(null == radioGroup)
		{
			layoutParams.height = ViewGroup.LayoutParams.WRAP_CONTENT;
			V.mods_container.setLayoutParams(layoutParams);
			V.mods_container.setNestedScrollingEnabled(false);
			return;
		}

		if(on)
		{
			int height = 0;
			for (int m = 0; m < VisibleRadioCount; m++)
			{
				View radio = radioGroup.getChildAt(m);
				height += Math.max(radio.getHeight(), radio.getMeasuredHeight());
			}
			layoutParams.height = height;
		}
		else
		{
			layoutParams.height = ViewGroup.LayoutParams.WRAP_CONTENT;
		}
		V.mods_container.setLayoutParams(layoutParams);
		V.mods_container.setNestedScrollingEnabled(on);
	}

	private String GetConsoleHeightText(int progress)
	{
		if(progress <= 0 || progress >= 100)
			return Q3ELang.tr(this, R.string.no_limit);
		else
			return progress + "%";
	}

	private void OpenGameList()
	{
		GameChooserFunc gameChooserFunc = new GameChooserFunc(this);
		Bundle bundle = new Bundle();
		bundle.putString("game", Q3EUtils.q3ei.game);
		gameChooserFunc.SetCallback(new Runnable() {
			@Override
			public void run()
			{
				ChangeGame((String)gameChooserFunc.GetResult());
			}
		});
		gameChooserFunc.Start(bundle);
	}



    private class ViewHolder
    {
        public MenuItem main_menu_game;
        public EditText edt_cmdline;
        public LinearLayout res_customlayout;
        public CheckBox nolight;
        public CheckBox useetc1cache;
        public CheckBox useetc1;
        public CheckBox usedxt;
        public RadioGroup r_harmclearvertexbuffer;
        public RadioGroup rg_msaa;
        public RadioGroup rg_color_bits;
        public RadioGroup rg_fs_game;
        public EditText edt_fs_game;
        public EditText edt_mouse;
        public EditText edt_path;
        public CheckBox hideonscr;
        public CheckBox mapvol;
        public CheckBox secfinglmb;
        public CheckBox smoothjoy;
        public CheckBox detectmouse;
        public LinearLayout layout_mouseconfig;
        public LinearLayout layout_manualmouseconfig;
        public Button launcher_tab1_game_lib_button;
        public EditText res_x;
        public EditText res_y;
        public Button launcher_tab1_edit_autoexec;
        public Button launcher_tab1_edit_doomconfig;
        public Button launcher_tab1_game_data_chooser_button;
        public RadioGroup rg_curpos;
        public EditText edt_harm_r_specularExponent;
        public RadioGroup rg_harm_r_lightingModel;
        public Button onscreen_button_setting;
        public LinearLayout launcher_tab1_user_game_layout;
        public RadioGroup rg_fs_q4game;
        public CheckBox fs_game_user;
        public LinearLayout launcher_tab2_volume_map_config_layout;
        public Spinner launcher_tab2_volume_up_map_config_keys;
        public Spinner launcher_tab2_volume_down_map_config_keys;
        public View main_ad_layout;
        public CheckBox launcher_tab2_enable_gyro;
        public LinearLayout launcher_tab2_enable_gyro_layout;
        public EditText launcher_tab2_gyro_x_axis_sens;
        public EditText launcher_tab2_gyro_y_axis_sens;
        public CheckBox auto_quick_load;
		public LinearLayout autoAspectRatio;
        public RadioGroup rg_fs_preygame;
        public CheckBox multithreading;
        public RadioGroup rg_s_driver;
        public CheckBox launcher_tab2_joystick_unfixed;
        public Button setup_onscreen_button_theme;
        public CheckBox using_mouse;
        public TextView tv_mprefs;
        public LinearLayout layout_mouse_device;
        public CheckBox find_dll;
		public EditText edt_harm_r_maxFps;
		public Button launcher_tab1_edit_cvar;
		public Button launcher_tab1_patch_resource;
		public EditText edt_cmdline_temp;
		public CheckBox skip_intro;
		public Button launcher_tab1_game_mod_button;
//		public CheckBox scale_by_screen_area;
		public RadioGroup rg_harm_r_shadow;
		public RadioGroup rg_opengl;
		public CheckBox cb_s_useOpenAL;
		public CheckBox cb_s_useEAXReverb;
		public Switch readonly_command;
		public CheckBox cb_stencilShadowTranslucent;
		public CheckBox cb_useHighPrecision;
		public CheckBox cb_renderToolsMultithread;
		public Switch editable_temp_command;
		public LinearLayout temp_cmdline;
		public LinearLayout idtech4_section;
		public LinearLayout opengl_section;
		public LinearLayout mod_section;
		public LinearLayout dll_section;
		public RadioGroup rg_fs_q1game;
		public RadioGroup rg_fs_q2game;
		public RadioGroup rg_fs_q3game;
		public RadioGroup rg_fs_rtcwgame;
		public RadioGroup rg_fs_tdmgame;
		public RadioGroup rg_fs_d3bfggame;
		public RadioGroup rg_fs_doomgame;
		public RadioGroup rg_fs_etwgame;
		public RadioGroup rg_fs_realrtcwgame;
		public RadioGroup rg_fs_fteqwgame;
		public Spinner launcher_tab2_joystick_visible;
		public TextView launcher_fs_game_subdir;
		public CheckBox cb_stencilShadowSoft;
		public EditText edt_harm_r_stencilShadowAlpha;
		public RadioGroup rg_r_autoAspectRatio;
		public CheckBox cb_stencilShadowCombine;
		public EditText edt_harm_r_shadowMapAlpha;
		public TextView launcher_fs_game_cvar;
		public SeekBar res_scale;
		public RadioGroup rg_scrres;
		public TextView tv_scrres_size;
		public TextView tv_scale_current;
		public LinearLayout res_scale_layout;
		public Button launcher_tab1_command_record;
		public Button launcher_tab1_create_shortcut;
		public CheckBox image_useetc2;
		public EditText edt_harm_r_specularExponentBlinnPhong;
		public EditText edt_harm_r_specularExponentPBR;
		public View show_directory_helper;
		public CheckBox cb_perforatedShadow;
		public Switch collapse_mods;
		public android.support.v4.widget.NestedScrollView mods_container;
		public LinearLayout mods_container_layout;
		public EditText edt_harm_r_ambientLightingBrightness;
		public LinearLayout yquake2_section;
		public RadioGroup yquake2_vid_renderer;
		public LinearLayout doom3bfg_section;
		public RadioGroup doom3bfg_useCompression;
		public CheckBox doom3bfg_useCompressionCache;
		public CheckBox doom3bfg_useMediumPrecision;
		public RadioGroup doom3bfg_rendererBackend;
		public LinearLayout realrtcw_section;
		public CheckBox realrtcw_sv_cheats;
		public RadioGroup realrtcw_shadows;
		public CheckBox realrtcw_stencilShadowPersonal;
		public LinearLayout etw_section;
		public CheckBox etw_omnibot_enable;
		public RadioGroup etw_shadows;
		public CheckBox etw_stencilShadowPersonal;
		public CheckBox etw_ui_disableAndroidMacro;
		public LinearLayout gzdoom_section;
		public CheckBox gzdoom_load_lights_pk3;
		public CheckBox gzdoom_load_brightmaps_pk3;
		public Button gzdoom_choose_extras_file;
		public RadioGroup gzdoom_vid_preferbackend;
		public RadioGroup gzdoom_gl_es;
		public RadioGroup gzdoom_gl_version;
		public LinearLayout tdm_section;
		public CheckBox tdm_useMediumPrecision;
		public LinearLayout fteqw_section;
		public RadioGroup fteqw_vid_renderer;
		public SeekBar consoleHeightFracValue;
		public TextView consoleHeightFracText;
		public RadioGroup rg_depth_bits;

        public void Setup()
        {
            edt_cmdline = findViewById(R.id.edt_cmdline);
            res_customlayout = findViewById(R.id.res_customlayout);
            nolight = findViewById(R.id.nolight);
            useetc1cache = findViewById(R.id.useetc1cache);
            useetc1 = findViewById(R.id.useetc1);
            usedxt = findViewById(R.id.usedxt);
            r_harmclearvertexbuffer = findViewById(R.id.r_harmclearvertexbuffer);
            rg_msaa = findViewById(R.id.rg_msaa);
            rg_color_bits = findViewById(R.id.rg_color_bits);
            rg_fs_game = findViewById(R.id.rg_fs_game);
            edt_fs_game = findViewById(R.id.edt_fs_game);
            edt_mouse = findViewById(R.id.edt_mouse);
            edt_path = findViewById(R.id.edt_path);
            hideonscr = findViewById(R.id.hideonscr);
            mapvol = findViewById(R.id.mapvol);
            secfinglmb = findViewById(R.id.secfinglmb);
            smoothjoy = findViewById(R.id.smoothjoy);
            detectmouse = findViewById(R.id.detectmouse);
            layout_mouseconfig = findViewById(R.id.layout_mouseconfig);
            layout_manualmouseconfig = findViewById(R.id.layout_manualmouseconfig);
            launcher_tab1_game_lib_button = findViewById(R.id.launcher_tab1_game_lib_button);
            res_x = findViewById(R.id.res_x);
            res_y = findViewById(R.id.res_y);
            launcher_tab1_edit_autoexec = findViewById(R.id.launcher_tab1_edit_autoexec);
            launcher_tab1_edit_doomconfig = findViewById(R.id.launcher_tab1_edit_doomconfig);
            launcher_tab1_game_data_chooser_button = findViewById(R.id.launcher_tab1_game_data_chooser_button);
            rg_curpos = findViewById(R.id.rg_curpos);
            edt_harm_r_specularExponent = findViewById(R.id.edt_harm_r_specularExponent);
            rg_harm_r_lightingModel = findViewById(R.id.rg_harm_r_lightingModel);
            onscreen_button_setting = findViewById(R.id.onscreen_button_setting);
            launcher_tab1_user_game_layout = findViewById(R.id.launcher_tab1_user_game_layout);
            rg_fs_q4game = findViewById(R.id.rg_fs_q4game);
            fs_game_user = findViewById(R.id.fs_game_user);
            launcher_tab2_volume_map_config_layout = findViewById(R.id.launcher_tab2_volume_map_config_layout);
            launcher_tab2_volume_up_map_config_keys = findViewById(R.id.launcher_tab2_volume_up_map_config_keys);
            launcher_tab2_volume_down_map_config_keys = findViewById(R.id.launcher_tab2_volume_down_map_config_keys);
            main_ad_layout = findViewById(R.id.main_ad_layout);
            launcher_tab2_enable_gyro = findViewById(R.id.launcher_tab2_enable_gyro);
            launcher_tab2_enable_gyro_layout = findViewById(R.id.launcher_tab2_enable_gyro_layout);
            launcher_tab2_gyro_x_axis_sens = findViewById(R.id.launcher_tab2_gyro_x_axis_sens);
            launcher_tab2_gyro_y_axis_sens = findViewById(R.id.launcher_tab2_gyro_y_axis_sens);
            auto_quick_load = findViewById(R.id.auto_quick_load);
			autoAspectRatio = findViewById(R.id.autoAspectRatio);
            rg_fs_preygame = findViewById(R.id.rg_fs_preygame);
            multithreading = findViewById(R.id.multithreading);
            rg_s_driver = findViewById(R.id.rg_s_driver);
            launcher_tab2_joystick_unfixed = findViewById(R.id.launcher_tab2_joystick_unfixed);
            setup_onscreen_button_theme = findViewById(R.id.setup_onscreen_button_theme);
            using_mouse = findViewById(R.id.using_mouse);
            tv_mprefs = findViewById(R.id.tv_mprefs);
            layout_mouse_device = findViewById(R.id.layout_mouse_device);
            find_dll = findViewById(R.id.find_dll);
			edt_harm_r_maxFps = findViewById(R.id.edt_harm_r_maxFps);
			launcher_tab1_edit_cvar = findViewById(R.id.launcher_tab1_edit_cvar);
			launcher_tab1_patch_resource = findViewById(R.id.launcher_tab1_patch_resource);
			edt_cmdline_temp = findViewById(R.id.edt_cmdline_temp);
			skip_intro = findViewById(R.id.skip_intro);
			launcher_tab1_game_mod_button = findViewById(R.id.launcher_tab1_game_mod_button);
//			scale_by_screen_area = findViewById(R.id.scale_by_screen_area);
			rg_harm_r_shadow = findViewById(R.id.rg_harm_r_shadow);
			rg_opengl = findViewById(R.id.rg_opengl);
			cb_s_useOpenAL = findViewById(R.id.cb_s_useOpenAL);
			cb_s_useEAXReverb = findViewById(R.id.cb_s_useEAXReverb);
			readonly_command = findViewById(R.id.readonly_command);
			cb_stencilShadowTranslucent = findViewById(R.id.cb_stencilShadowTranslucent);
			cb_useHighPrecision = findViewById(R.id.cb_useHighPrecision);
			cb_renderToolsMultithread = findViewById(R.id.cb_renderToolsMultithread);
			editable_temp_command = findViewById(R.id.editable_temp_command);
			temp_cmdline = findViewById(R.id.temp_cmdline);
			idtech4_section = findViewById(R.id.idtech4_section);
			opengl_section = findViewById(R.id.opengl_section);
			dll_section = findViewById(R.id.dll_section);
			mod_section = findViewById(R.id.mod_section);
			rg_fs_q1game = findViewById(R.id.rg_fs_q1game);
			rg_fs_q2game = findViewById(R.id.rg_fs_q2game);
			rg_fs_q3game = findViewById(R.id.rg_fs_q3game);
			rg_fs_rtcwgame = findViewById(R.id.rg_fs_rtcwgame);
			rg_fs_tdmgame = findViewById(R.id.rg_fs_tdmgame);
			rg_fs_d3bfggame = findViewById(R.id.rg_fs_d3bfggame);
			rg_fs_doomgame = findViewById(R.id.rg_fs_doomgame);
			launcher_tab2_joystick_visible = findViewById(R.id.launcher_tab2_joystick_visible);
			launcher_fs_game_subdir = findViewById(R.id.launcher_fs_game_subdir);
			cb_stencilShadowSoft = findViewById(R.id.cb_stencilShadowSoft);
			edt_harm_r_stencilShadowAlpha = findViewById(R.id.edt_harm_r_stencilShadowAlpha);
			rg_r_autoAspectRatio = findViewById(R.id.rg_r_autoAspectRatio);
			cb_stencilShadowCombine = findViewById(R.id.cb_stencilShadowCombine);
			edt_harm_r_shadowMapAlpha = findViewById(R.id.edt_harm_r_shadowMapAlpha);
			launcher_fs_game_cvar = findViewById(R.id.launcher_fs_game_cvar);
			res_scale = findViewById(R.id.res_scale);
			rg_scrres = findViewById(R.id.rg_scrres);
			tv_scrres_size = findViewById(R.id.tv_scrres_size);
			tv_scale_current = findViewById(R.id.tv_scale_current);
			res_scale_layout = findViewById(R.id.res_scale_layout);
			launcher_tab1_command_record = findViewById(R.id.launcher_tab1_command_record);
			launcher_tab1_create_shortcut = findViewById(R.id.launcher_tab1_create_shortcut);
			image_useetc2 = findViewById(R.id.image_useetc2);
			edt_harm_r_specularExponentBlinnPhong = findViewById(R.id.edt_harm_r_specularExponentBlinnPhong);
			edt_harm_r_specularExponentPBR = findViewById(R.id.edt_harm_r_specularExponentPBR);
			show_directory_helper = findViewById(R.id.show_directory_helper);
			cb_perforatedShadow = findViewById(R.id.cb_perforatedShadow);
			collapse_mods = findViewById(R.id.collapse_mods);
			mods_container = findViewById(R.id.mods_container);
			mods_container_layout = findViewById(R.id.mods_container_layout);
			edt_harm_r_ambientLightingBrightness = findViewById(R.id.edt_harm_r_ambientLightingBrightness);
			rg_fs_etwgame = findViewById(R.id.rg_fs_etwgame);
			rg_fs_realrtcwgame = findViewById(R.id.rg_fs_realrtcwgame);
			rg_fs_fteqwgame = findViewById(R.id.rg_fs_fteqwgame);
			yquake2_section = findViewById(R.id.yquake2_section);
			yquake2_vid_renderer = findViewById(R.id.yquake2_vid_renderer);
			doom3bfg_section = findViewById(R.id.doom3bfg_section);
			doom3bfg_useCompression = findViewById(R.id.doom3bfg_useCompression);
			doom3bfg_rendererBackend = findViewById(R.id.doom3bfg_rendererBackend);
			doom3bfg_useCompressionCache = findViewById(R.id.doom3bfg_useCompressionCache);
			doom3bfg_useMediumPrecision = findViewById(R.id.doom3bfg_useMediumPrecision);
			realrtcw_section = findViewById(R.id.realrtcw_section);
			realrtcw_sv_cheats = findViewById(R.id.realrtcw_sv_cheats);
			realrtcw_shadows = findViewById(R.id.realrtcw_shadows);
			realrtcw_stencilShadowPersonal = findViewById(R.id.realrtcw_stencilShadowPersonal);
			etw_section = findViewById(R.id.etw_section);
			etw_omnibot_enable = findViewById(R.id.etw_omnibot_enable);
			etw_shadows = findViewById(R.id.etw_shadows);
			etw_stencilShadowPersonal = findViewById(R.id.etw_stencilShadowPersonal);
			etw_ui_disableAndroidMacro = findViewById(R.id.etw_ui_disableAndroidMacro);
			gzdoom_section = findViewById(R.id.gzdoom_section);
			gzdoom_load_lights_pk3 = findViewById(R.id.gzdoom_load_lights_pk3);
			gzdoom_load_brightmaps_pk3 = findViewById(R.id.gzdoom_load_brightmaps_pk3);
			gzdoom_choose_extras_file = findViewById(R.id.gzdoom_choose_extras_file);
			gzdoom_vid_preferbackend = findViewById(R.id.gzdoom_vid_preferbackend);
			gzdoom_gl_es = findViewById(R.id.gzdoom_gl_es);
			gzdoom_gl_version = findViewById(R.id.gzdoom_gl_version);
			tdm_section = findViewById(R.id.tdm_section);
			tdm_useMediumPrecision = findViewById(R.id.tdm_useMediumPrecision);
			fteqw_section = findViewById(R.id.fteqw_section);
			fteqw_vid_renderer = findViewById(R.id.fteqw_vid_renderer);
			consoleHeightFracValue = findViewById(R.id.consoleHeightFracValue);
			consoleHeightFracText = findViewById(R.id.consoleHeightFracText);
			rg_depth_bits = findViewById(R.id.rg_depth_bits);
        }
    }
}
